<?php
namespace Util;

use Zeedhi\Framework\DependencyInjection\InstanceManager;

class Exception extends \Exception {

    public static function invalidDataBase($databaseDriver) {
        return new static('Invalid DataBase driver "'.$databaseDriver.'"');
    }

    public static function logException($exception) {
        try {
            if (PHP_OS === "Linux" || preg_match('/Linux/', PHP_OS)){
                $logPath = sys_get_temp_dir() .DIRECTORY_SEPARATOR. 'LOG';
            } else {
                $logPath = InstanceManager::getInstance()->getParameter('LOG_PATH');
            }
            if (!realpath($logPath)){
                mkdir($logPath);
            }
            $logPath = $logPath . DIRECTORY_SEPARATOR . 'logException';
            if (!realpath($logPath)){
                mkdir($logPath);
            }
            $logPath = $logPath . DIRECTORY_SEPARATOR . 'NRORG_'.self::getNRORGSession();
            if (!realpath($logPath)){
                mkdir($logPath);
            }

            $dateTime = new \DateTime();
            $logFile = 'logException'. "_" . $dateTime->format('d_m_Y') . '.txt';
            $logText = "[" . $dateTime->format("d/m/Y H:i:s") . "]" . PHP_EOL ."log: " . $exception->getMessage() . PHP_EOL . PHP_EOL;
            file_put_contents($logPath . DIRECTORY_SEPARATOR . $logFile, $logText, FILE_APPEND);
        } catch (\Exception $e) {
            // falha ao salvar log
        }
    }

    public static function getNRORGSession(){
        try {
            $NRORG = json_decode($_SESSION['_sf2_attributes']['USERINFO'],true)['NRORG'];
            if(!empty($NRORG)){
                return $NRORG;
            }
            return "";
        } catch(\Exception $e){ }
        return "";
    }

}