function PaymentController(ScreenService, UtilitiesService, PaymentService, AccountController, PaymentRepository, IntegrationService, ParamsClientRepository, GetConsumerLimit, Query,
	PermissionService, OperatorRepository, PrinterService, ParamsGroupPriceChart, ParamsPriceChart, GroupPriceChart, PriceChart, AccountService, WindowService, TableController, CarrinhoDesistencia,
	PerifericosService, ProdSenhaPed, templateManager, AccountSaleCode, AccountGetAccountDetails, GetTipoProd,
	metaDataFactory, EventManager) {

	// define por IDTIPORECE se pagamento tem valor máximo e se possibilita editar valor de pagamento
	var PAYMENT_TYPE = {
		'1': { max: true, repique: true },
		'2': { max: true, repique: true },
		'3': { max: false, repique: false },
		'4': { max: false, repique: true },
		'5': { max: false, repique: false },
		'6': { max: false, repique: false },
		'7': { max: false, repique: false },
		'8': { max: false, repique: false },
		'9': { max: true, repique: false },
		'A': { max: true, repique: false },
		'B': { max: false, repique: false },
		'C': { max: false, repique: false },
		'E': { max: true, repique: false },
		'F': { max: true, repique: true },
		'G': { max: true, repique: true },
		'H': { max: true, repique: true },
		'K': { max: true, repique: false },
		'W': { max: true, repique: false }
	};
	var MESSAGE = {
		VR_MIN: 'Valor inválido.',
		VR_MAX: 'Valor máximo excedido.',
		VR_MAX_DISCOUNT: 'Operação bloqueada. Essa venda tem ',
		VR_MAX_DISCOUNT_P2:' produtos e cada produto deve ter o valor mínimo de R$0,01',
		VR_MAX_DISCOUNT_P3:' Valor máximo de desconto é de R$',
		END_PAYMENT: 'Deseja finalizar a venda?',
		ADD_PAYMENT: 'Recebimento adicionado.',
		ATT_PAYMENT: 'Recebimento alterado.',
		FAIL_PAYMENT: 'Operação bloqueada. Valor total da venda não atingido.',
		BLOCK_PAYMENT: 'Operação bloqueada. Valor total da venda já atingido.',
		REMOVE_PAYMENT: 'Deseja remover o pagamento?',
		PAYMENT_COMPLETED: 'Venda realizada. ',
		CANCEL_INTEGRATION: 'Transações eletrônicas pendentes. Deseja cancelá-las?',
		NFCE_CONTINGENCY: 'NFCE emitido em modo de contigência.',
		VR_MAX_SALDO: 'O cliente não possui saldo disponivel.',
		INFORM_CLIENT_CRE: 'Favor selecionar o consumidor antes de receber com crédito pessoal.',
		INFORM_CLIENT_DEB: 'Favor selecionar o consumidor antes de receber com débito consumidor.',
		VR_SALDO_LIM: 'Operação bloqueada. O limite de crédito do consumidor será excedido. Consumo diário disponível: R$ ',
		LOW_CREDIT: 'O saldo restante deste consumidor é de: R$ ',
		NO_DISCOUNT: 'Não há desconto a ser removido.',
		NO_CREDIT: 'Consumidor sem saldo disponível.',
		REMOVE_DISCOUNT: 'Deseja remover desconto já aplicado?',
		REMOVE_DISCOUNT_PROMOCOESINT: 'Existem descontos de Promoções aplicados. Deseja remover os desconto das Promoções?',
		BLOCK_DISCOUNT: 'Operação bloqueada. Não é possível informar desconto enquanto existir recebimentos aplicados.',
		INATIVE_CONSUMER: 'Operação bloqueada. O Consumidor está inativo.',
		CONFIRM_PRINT: 'Deseja imprimir o cupom fiscal?',
		NO_ADDITION: 'Operação bloqueada. Esta venda não possui Gorjeta.',
		ALTER_ADDITION: 'Deseja ajustar a Gorjeta?',
		PRINT_VIA_CLI: 'Deseja imprimir a via do cliente?',
		NOT_ENOUGH_DEBIT: 'Saldo insuficiente para realizar a venda somente via débito consumidor. Favor complementar com outro tipo de recebimento.<br><br>Limite disponível: R$ ',
		NOT_ONLY_DEBIT: 'Operação bloqueada. Débito Consumidor não pode ser utilizado com outros tipos de recebimento.',
		BLOCK_PERSONAL_CREDIT: 'Operação bloqueada. Este tipo de recebimento não pode efetuar compra de crédito pessoal.',
		BLOCK_CREDIT_MULTIPLE: 'Crédito Fidelidade não pode ser utilizado junto com Crédito Pessoal.',
		DEBIT_WITH_DISCOUNT: 'Não é possível realizar uma venda de débito com desconto aplicado. Favor remover o desconto aplicado e tente novamente.',
        ALERT_WIBX: 'A transação WiBX não será cancelada. Após a remoção do pagamento, esta operação não poderá ser desfeita. Deseja mesmo remover este pagamento?',
        BACK_WIBX: 'Existem transações WiBX que foram realizadas. Ao sair da tela de pagamento, estas transações serão descartadas sem serem canceladas. Deseja continuar?',
        ERRO_VALIDATE_ID: 'Preencha com os StoneIDs de todas as transações.'
	};
	var CONSUMER_LIMIT = 300000;
	var mustComplete = false;
	var telConsumidor = null;

	var self = this;

	this.limpadesconto = true;

	this.receivePayment = function (widget, tiporece, adiantamento) {
			var promessa = Promise.resolve({});
			(operatorData.modoHabilitado!='B'?PaymentService.getValidaVendaMesa():promessa).then(function(validaVendaMesa){
				if(validaVendaMesa[0]){
					if(validaVendaMesa[0].error){
						if(validaVendaMesa[0].message){
							ScreenService.showMessage(validaVendaMesa[0].message, 'alert');
							return;
						}
					}
				}
				PaymentRepository.findOne().then(function (paymentData) {
					saleParameters = paymentData;
					setTimeout(function(){ScreenService.hideLoader();},30);
					setTimeout(function(){ScreenService.hideLoader();},70);
					PaymentService.getValidaTipoConsReceb(tiporece.CDTIPORECE, paymentData.CDCLIENTE, paymentData.CDCONSUMIDOR).then(function(validaTipoConsReceb){
						if(!validaTipoConsReceb[0].boTipoConsReceb){
							ScreenService.showMessage('Tipo de recebimento não permitido para este consumidor ou nenhum consumidor foi informado para esta venda.', 'alert').then(function(){
								ScreenService.closePopup();
							});
							ScreenService.closePopup();
							setTimeout(function(){ScreenService.closePopup();},50);
						}
					},function(){
						setTimeout(function(){ScreenService.closePopup();},50);
					});

					var boPermiteContinuar = false;
					if((saleParameters.descontoPromocoesIntPayment||null)){
						if(saleParameters.descontoPromocoesIntPayment[0]){
							var boPagamentosAnteriores = false;
							var boPagamentoAtual = false;
							var valorPago = 0;
							if(tiporece){
								if(tiporece.CDTIPORECE == saleParameters.descontoPromocoesIntPayment[0].IDPROMOCOM){
									boPagamentoAtual = true;
								}
							}
							boPermiteContinuar = boPagamentoAtual;
							if(!boPermiteContinuar){
								var stPagamentosDisponiveis = "";
								ParamsPriceChart.findAll().then(function(paymentTypes){
									paymentTypes.forEach(function(data){
										if(data.CDTIPORECE == saleParameters.descontoPromocoesIntPayment[0].IDPROMOCOM){
											if(stPagamentosDisponiveis==""){
												stPagamentosDisponiveis = data.DSBUTTON;
											} else {
												stPagamentosDisponiveis = stPagamentosDisponiveis+", "+data.DSBUTTON;
											}
										}
									});
									if(stPagamentosDisponiveis!=""){
										stPagamentosDisponiveis = ": "+stPagamentosDisponiveis;
									}
									ScreenService.showMessage('A promoção '+saleParameters.descontoPromocoesIntPayment[0].NMPROMOCOM+' é condicionado ao meio de pagamento. Por favor selecione um meio de pagamento compatível'+stPagamentosDisponiveis, 'alert');
								});
								return;
							}
						}
					} else if(tiporece.IDTIPORECE=='K') {
						boJaExiste = false;
						arrPagamento = null;
						if(paymentData.TIPORECE){
							for (index = 0; index < paymentData.TIPORECE.length; index++) {
								if(paymentData.TIPORECE[index].IDTIPORECE=='K'){
									boJaExiste = true;
									arrPagamento = paymentData.TIPORECE[index];
									//ScreenService.showMessage('Não é permitido utilizar mais de um Cartão Todo na ' + 
									//'mesma venda.', 'alert');
								}
							}
						}
						var container = templateManager.container;
						self.criaWidget(container,'popupBuscaSaldoCartaoTodo');
						var popup = container.getWidget('popupBuscaSaldoCartaoTodo');
						self.handleCartaoTodoPopup(popup);
						popup.FALTANTE = paymentData.DATASALE.FALTANTE;
						if(!boJaExiste){
							popup.tiporece = tiporece;
							popup.getField('card_password').setValue("");
							popup.getField('saldodisponivel').setValue(0);
							popup.getField('saldoutilizado').setValue(0);
							popup.getField('saldoutilizado').isVisible = false;
							popup.getField('saldodisponivel').isVisible = false;
							popup.getField('card_password').isVisible = false;
							popup.getField('card_number').readOnly = false;

							popup.getAction('ok').label='Consultar';
							ScreenService.openPopup(popup);
						} else {
							popup.getField('saldoutilizado').isVisible = true;
							popup.getField('saldodisponivel').isVisible = true;
							popup.getField('card_password').isVisible = true;
							popup.getField('card_number').readOnly = true;

							popup.getAction('ok').label='Confirmar';
							PaymentService.handleRemovePayment(arrPagamento).then(function (handleRemovePaymentResult) {
								if (!handleRemovePaymentResult.error) {
									self.criaWidget(widget.container,'paymentList');
									var widgetPaymentList = widget.container.getWidget('paymentList');
									self.attStripeData(widgetPaymentList);
									self.attPaymentList(widgetPaymentList);
									PaymentRepository.findOne().then(function (paymentData) {
										popup.FALTANTE = paymentData.DATASALE.FALTANTE;
										ScreenService.openPopup(popup);
									});
								} else {
									ScreenService.showMessage(handleRemovePaymentResult.message, 'alert');
								}
							});
						}
						return;
					}
					if (operatorData.IDCOLETOR !== 'C' && operatorData.VROBRIGCPFNOTA != null && 
						paymentData.DATASALE.TOTALVENDA >= operatorData.VROBRIGCPFNOTA && 
						(_.isEmpty(paymentData.NRINSCRCONS) || _.isEmpty(paymentData.DSENDECONSVENDA))){
						ScreenService.showMessage('Venda com valor total superior ao permitido para destinatário ' + 
							'não-identificado. CPF e endereço do consumidor devem ser informados!', 'alert');
						return;
					}

					var toPay = paymentData.DATASALE.FALTANTE;
					if (!toPay){
						ScreenService.showMessage(MESSAGE.BLOCK_PAYMENT, 'alert');
						return;
					}
					if(operatorData.FIDELIDADEONLINEATIVO){
						PaymentService.temCampanhaFidelidadeOnline(operatorData.CDFILIAL).then(function(result){
							PaymentService.getPaymentValue().then(function (DATASALE) {
								if (operatorData.FIDELIDADEONLINEATIVO && !_.isEmpty(result[0].result) && !DATASALE.FIDELITYBYPASS){
									self.checkShowFidelidadeOnline(operatorData, paymentData, widget, tiporece, toPay, adiantamento);
								} else self.openPopupToStartPayment(paymentData, widget, tiporece, toPay, adiantamento);
							});
						});
					} else self.openPopupToStartPayment(paymentData, widget, tiporece, toPay, adiantamento);
				});
			});
	};

	this.checkShowFidelidadeOnline = function(operatorData, paymentData, widget, tiporece, toPay, adiantamento) {
		if(paymentData.CDCLIENTE && paymentData.CDCONSUMIDOR) {
			PaymentService.checkSaldoFidelidadeOnline(operatorData.CDFILIAL, paymentData.CDCLIENTE, paymentData.CDCONSUMIDOR).then(function(result) {
	
					if(typeof result[0].result === 'string') {
						ScreenService.showMessage(result[0].result);
					}

					var saldo = (typeof result[0].result === 'object' && !_.isEmpty(result[0].result)) ? result[0].result.balance[0] : 0;
					var consumerName = (typeof result[0].result === 'object' && !_.isEmpty(result[0].result.consumerName)) ? result[0].result.consumerName[0] : '';
					var temSaldo = saldo > 0;

					if(temSaldo) {
						ScreenService.confirmMessage("O consumidor "+consumerName+
							" possui um saldo total de "+saldo+" para ser utilizado. Deseja utilizar este "+
							"valor como desconto na venda? ", 
							'question',
							function () {
								self.criaWidget(widget.container,'discountPopup');
								var discountPopup = widget.container.getWidget('discountPopup');
								var TIPODESCONTO = discountPopup.getField('TIPODESCONTO');
								var VRDESCONTO = discountPopup.getField('VRDESCONTO');

								TIPODESCONTO.value('V');
								VRDESCONTO.value(saldo);

								self.setDiscount(discountPopup);
								paymentData.DATASALE.VRDESCONTO = (toPay < saldo) ? toPay.toFixed(2) : saldo;
								toPay = (toPay - saldo) > 0 ? (toPay - saldo) : 0.01;
								self.openPopupToStartPayment(paymentData, widget, tiporece, toPay, adiantamento);
							}, function () {
								self.openPopupToStartPayment(paymentData, widget, tiporece, toPay, adiantamento);
							}
						);
					} else {
						self.openPopupToStartPayment(paymentData, widget, tiporece, toPay, adiantamento);
					}
				});
		} else {
			self.criaWidget(widget.container, 'fidelidadeOnline');
			self.criaWidget(widget.container, 'popupConsumidorBalcao');

			window.paramsClose = {};
			window.paramsClose.paymentData = paymentData;
			window.paramsClose.widget = widget;
			window.paramsClose.tiporece = tiporece;
			window.paramsClose.toPay = toPay;
			window.paramsClose.adiantamento = adiantamento;

			ScreenService.openPopup(widget.container.getWidget('fidelidadeOnline'));
		}
	};

	this.openPopupToStartPayment = function(paymentData, widget, tiporece, toPay, adiantamento) {
		if (!paymentData.CREDITOPESSOAL || !_.includes(["A", "9"], tiporece.IDTIPORECE)) {
			switch (tiporece.IDTIPORECE) {
				case 'A': // debito pessoal
					self.recievePersonalDebit(paymentData, widget, tiporece, toPay);
					break;
				case '9': // credito pessoal
					self.recievePersonalCredit(paymentData, widget, tiporece, toPay);
					break;
				default:
					self.openPaymentPopup(widget.container, tiporece, toPay, false, adiantamento);
			}
		} else {
			ScreenService.showMessage(MESSAGE.BLOCK_PERSONAL_CREDIT);
		}
	};

	this.closePopupFidelidadeOnline = function(widget) {
		ScreenService.closePopup(widget);
		self.openPopupToStartPayment(window.paramsClose.paymentData, window.paramsClose.widget, window.paramsClose.tiporece, window.paramsClose.toPay, window.paramsClose.adiantamento);
	};

	this.recievePersonalDebit = function (paymentData, widget, tiporece, toPay) {
		OperatorRepository.findOne().then(function(operatorData) {
			if (!paymentData.CDCLIENTE || !paymentData.CDCONSUMIDOR) {
				ScreenService.showMessage(MESSAGE.INFORM_CLIENT_DEB, 'alert').then(function() {
					if(operatorData.modoHabilitado == 'B')  {
						self.openPopupConsumidor(widget.container);
					}
				});
				return;
			}
			if (!_.isEmpty(paymentData.TIPORECE)) {
				ScreenService.showMessage(MESSAGE.NOT_ONLY_DEBIT, 'alert');
				return;
			}
			if (paymentData.DATASALE.PCTDESCONTO > 0 || paymentData.DATASALE.VRDESCONTO > 0) {
				ScreenService.showMessage(MESSAGE.DEBIT_WITH_DISCOUNT, 'alert');
				return;
			}
	
			PaymentService.getConsumerLimit(paymentData.CDCLIENTE, paymentData.CDCONSUMIDOR, 'debito').then(function (consumerLimit) {
				var SALDO_ATUAL = consumerLimit[0].SALDO_ATUAL;
				var LIMITE_ATUAL = consumerLimit[0].LIMITE_ATUAL;
				var CONSUMO_DIA = consumerLimit[0].CONSUMO_DIA;
				var CONSUMO_MES = consumerLimit[0].CONSUMO_MES;
				var VRLIMDEBCONS = consumerLimit[0].VRLIMDEBCONS;
				var VRMAXDEBCONS = consumerLimit[0].VRMAXDEBCONS;
				var VRMAXCONSDIAD = consumerLimit[0].VRMAXCONSDIAD;
				var VRMAXCONSMESD = consumerLimit[0].VRMAXCONSMESD;
				var VRAVIDEBCONS = consumerLimit[0].VRAVIDEBCONS;
				var IDPERCOMVENCPDC = consumerLimit[0].IDPERCOMVENCPDC;
				var SALDO_BASICO  = consumerLimit[0].SALDO_BASICO;
				var SALDO_EXTRA = consumerLimit[0].SALDO_EXTRA;
	
				var totalDebito = parseFloat((paymentData.DATASALE.TOTALVENDA - paymentData.DATASALE.REALSUBSIDY).toFixed(2));
	
				PaymentService.getTipoProd(paymentData.ITEMVENDA, paymentData.CDCLIENTE, paymentData.CDCONSUMIDOR).then(function(tipoProdutos){
					if (consumerLimit[0].IDSALDEXTDEBCON != 'S' && !IDPERCOMVENCPDC && VRMAXCONSMESD && totalDebito + CONSUMO_MES > VRMAXCONSMESD) {
						ScreenService.showMessage('Operação bloqueada. O consumidor ' + consumerLimit[0].CDCONSUMIDOR + ' - ' + consumerLimit[0].NMCONSUMIDOR + ' não pode exceder o valor máximo de consumo mensal por tipo de consumidor/loja - R$ ' + UtilitiesService.toCurrency(VRMAXCONSMESD) + '. Favor verificar parametrização no sistema.');
					}
					else if (consumerLimit[0].IDSALDEXTDEBCON != 'S' && !IDPERCOMVENCPDC && VRMAXCONSDIAD && totalDebito + CONSUMO_DIA > VRMAXCONSDIAD) {
						ScreenService.showMessage('Operação bloqueada. O consumidor ' + consumerLimit[0].CDCONSUMIDOR + ' - ' + consumerLimit[0].NMCONSUMIDOR + ' não pode exceder o valor máximo de consumo diário por tipo de consumidor/loja - R$ ' + UtilitiesService.toCurrency(VRMAXCONSDIAD) + '. Favor verificar parametrização no sistema.');
					}
					else if (consumerLimit[0].IDSALDEXTDEBCON != 'S' && !IDPERCOMVENCPDC && VRMAXDEBCONS && totalDebito + CONSUMO_DIA > VRMAXDEBCONS) {
						ScreenService.showMessage('Operação bloqueada. O consumidor ' + consumerLimit[0].CDCONSUMIDOR + ' - ' + consumerLimit[0].NMCONSUMIDOR + ' não pode exceder o valor de consumo diário - R$ ' + UtilitiesService.toCurrency(VRMAXDEBCONS) + '. Favor verificar parametrização no sistema.');
					}
					else if (consumerLimit[0].IDSALDEXTDEBCON != 'S' && !IDPERCOMVENCPDC && VRLIMDEBCONS && SALDO_ATUAL - totalDebito < VRLIMDEBCONS) {
						ScreenService.showMessage('Operação bloqueada. Saldo do consumidor não pode ficar inferior a R$ ' + UtilitiesService.toCurrency(VRLIMDEBCONS) + '. Saldo atual : R$ ' + UtilitiesService.toCurrency(SALDO_ATUAL) + '.', 'alert');
					}
					else if(consumerLimit[0].IDSALDEXTDEBCON == 'S' && IDPERCOMVENCPDC && tipoProdutos[0].VALOR_EXTRA > SALDO_EXTRA){
						ScreenService.showMessage('Operação bloqueada. O consumidor não possui Saldo Extra suficiente para finalizar a venda. Saldo Extra R$ ' + UtilitiesService.toCurrency(SALDO_EXTRA) + '.', 'alert');
					}
					else if(consumerLimit[0].IDSALDEXTDEBCON == 'S' && IDPERCOMVENCPDC && tipoProdutos[0].VALOR_BASICO > SALDO_BASICO){
						ScreenService.showMessage('Operação bloqueada. O consumidor não possui Saldo Básico suficiente para finalizar a venda. Saldo Básico R$ ' + UtilitiesService.toCurrency(SALDO_BASICO) + '.', 'alert');
					}
					else {
						var toPay = paymentData.DATASALE.TOTALVENDA;
						if (LIMITE_ATUAL != null) {
							var paymentDiff = parseFloat((LIMITE_ATUAL - toPay + paymentData.DATASALE.REALSUBSIDY).toFixed(2));
							if (paymentDiff < 0) {
								toPay = LIMITE_ATUAL;
								ScreenService.showMessage(MESSAGE.NOT_ENOUGH_DEBIT + UtilitiesService.toCurrency(LIMITE_ATUAL), 'alert').then(function() {
									mustComplete = true;
									self.openPaymentPopup(widget.container, tiporece, toPay, false);
								});
							}
						}
	
						if (toPay > 0) {
							self.openPaymentPopup(widget.container, tiporece, toPay, false);
						}
					}
				});
			});
		});
	};

	this.showBasicoExtra = function(paymentData, stripeWidget){
		//var payMenuWidget = widget.container.getWidget('paymentMenu') || widget.container.getWidget('advancePaymentMenu');
		//var stripeWidget = payMenuWidget.container.getWidget('paymentStripe');
		if(operatorData.IDSALDEXTDEBCON == 'S'){
			stripeWidget.getField('saldoBasicoDia').isVisible = true;
			stripeWidget.getField('saldoExtraMes').isVisible = true;
			PaymentService.getConsumerLimit(paymentData.CDCLIENTE, paymentData.CDCONSUMIDOR, 'debito').then(function (consumerLimit) {
				stripeWidget.getField('saldoBasico').isVisible = true;
				stripeWidget.getField('saldoBasico').setValue(UtilitiesService.toCurrency(consumerLimit[0].SALDO_BASICO));
				stripeWidget.getField('saldoExtra').isVisible = true;
				stripeWidget.getField('saldoExtra').setValue(UtilitiesService.toCurrency(consumerLimit[0].SALDO_EXTRA));
			});
		}
		stripeWidget.activate().then(function(){
			if(stripeWidget.container.getWidget('paymentMenu')){
				stripeWidget.container.getWidget('paymentMenu').activate();
			}
		});
	};

	this.recievePersonalCredit = function (paymentData, widget, tiporece, toPay) {
		OperatorRepository.findOne().then(function(operatorData) {
			if (paymentData.DATASALE.FIDELITYDISCOUNT > 0) {
				ScreenService.showMessage(MESSAGE.BLOCK_CREDIT_MULTIPLE, 'alert');
				return;
			}
			if (paymentData.CDCLIENTE && paymentData.CDCONSUMIDOR) {
				PaymentService.getConsumerLimit(paymentData.CDCLIENTE, paymentData.CDCONSUMIDOR, 'credito').then(function (consumerLimit) {
					var limiteDisponivel = consumerLimit[0].limiteDisponivel;
					var aceitaSaldNegativo = consumerLimit[0].aceitaSaldNegativo;
					if (limiteDisponivel && limiteDisponivel - paymentData.DATASALE.TOTALVENDA < 0) {
						ScreenService.showMessage(MESSAGE.VR_SALDO_LIM + UtilitiesService.toCurrency(limiteDisponivel), 'alert').then(function() {
							mustComplete = true;
							self.openPaymentPopup(widget.container, tiporece, toPay, false);
						});
					}
					else if (!aceitaSaldNegativo && consumerLimit[0].saldoDisponivel <= 0) {
						ScreenService.showMessage(MESSAGE.NO_CREDIT);
					}
					else {
						var saldoDisponivel = consumerLimit[0].saldoDisponivel;
						if (!aceitaSaldNegativo && saldoDisponivel < paymentData.DATASALE.FALTANTE) {
							toPay = saldoDisponivel;
							var infoCliente = ' ( ' + paymentData.CDCONSUMIDOR + ' - ' + paymentData.NMCONSUMIDOR + ' )';
							ScreenService.showMessage(MESSAGE.LOW_CREDIT + UtilitiesService.toCurrency(saldoDisponivel) + infoCliente, 'alert').then(function() {
								mustComplete = true;
								self.openPaymentPopup(widget.container, tiporece, toPay, false);
							});
						} else {
							self.openPaymentPopup(widget.container, tiporece, toPay, false);
						}
					}
				});
			} else {
				ScreenService.showMessage(MESSAGE.INFORM_CLIENT_CRE).then(function() {
					if(operatorData.modoHabilitado == 'B')  {
						self.openPopupConsumidor(widget.container);
					}
				});
			}
		});
	};

	this.openPaymentPopup = function (paymentPopup, tiporece, toPay, locked, adiantamento) {
		self.criaWidget(paymentPopup,'paymentPopup');
		paymentPopup = paymentPopup.getWidget('paymentPopup');
		self.setPaymentPopupProperty(paymentPopup, tiporece, toPay, locked);
		ScreenService.openPopup(paymentPopup);
	};

	this.setPaymentPopupProperty = function (openPopup, tiporece, toPay, locked) {
		if(toPay){
			arrOptions = [];
			arrOptions.allowZero = true;
			arrOptions.defaultZero = true;
			arrOptions.precision = 2;
			arrOptions.showSymbol = false;
			toPay = $.currency.string(toPay, arrOptions);
			toPay = UtilitiesService.getFloat(toPay);
		}
			var fieldValue = openPopup.getField('VRMOVIVEND');
			var fieldNSU = openPopup.getField('CDNSUHOSTTEF');

			openPopup.label = tiporece.DSBUTTON;
			openPopup.currentRow = self.currentRowDefaultValue(tiporece);

			//Controle de valores máximos possíveis no pagamento do repique, respeitando a parametrização.
			if (operatorData.IDTPCONTRREPIQ !== 'N' && tiporece.IDUTCONTRREPIQ !== 'N') {
				fieldValue.range.max = null;
			} else {
				fieldValue.range.max = (PAYMENT_TYPE[tiporece.IDTIPORECE].max) ? toPay : null;
			}
			fieldValue.setValue(toPay);
			fieldValue.readOnly = locked;

			fieldNSU.maxlength = operatorData.QTDMAXDIGNSU || 10;

			if (!self.showFieldNSU(tiporece, operatorData)) {
				fieldValue.class = "6 center-align-field";
				fieldNSU.isVisible = false;
			} else {
				fieldValue.class = 6;
				fieldNSU.isVisible = true;
			}
	};

	this.currentRowDefaultValue = function (tiporece) {
		return {
			tiporece: tiporece,
			eletronicTransacion: { status: false, data: IntegrationService.integrationData() }
		};
	};

	this.showFieldNSU = function (tiporece, operatorData) {
		// validação para mostrar field NSU nos recebimentos do tipo POS
		return tiporece.IDDESABTEF === 'S' && operatorData.IDSOLICITANSU === 'S' &&
			_.includes(PaymentService.PAYMENT_INTEGRATION, tiporece.IDTIPORECE);
	};

	this.setPayment = function (widget, adiantamento) {
		var currentRow = _.clone(widget.currentRow);
		var widgetPayment = (!adiantamento) ? widget.container.getWidget('paymentMenu') : widget.container.getWidget('advancePaymentMenu');
		if(!widgetPayment && adiantamento===undefined && widget.container.getWidget('advancePaymentMenu')){
			widgetPayment = widget.container.getWidget('advancePaymentMenu');
			adiantamento=true;
		}
		var valorRecebimento = UtilitiesService.getFloat(widget.getField('VRMOVIVEND').value());

		stVRMOVIVEND = widget.getField('VRMOVIVEND').value();
		if (typeof stVRMOVIVEND !== 'string') stVRMOVIVEND = stVRMOVIVEND.toString();

		if (stVRMOVIVEND.indexOf(",") >= 0 || stVRMOVIVEND.indexOf(".") >= 0 ){
			stVRMOVIVEND.substr((stVRMOVIVEND.indexOf(",")>=0 ? stVRMOVIVEND.indexOf(",") : stVRMOVIVEND.indexOf(".")) +1);
			if(stVRMOVIVEND.length > 2){
				arrOptions = [];
				/*if(widget.getField("VRMOVIVEND")){
					if(widget.getField("VRMOVIVEND").mask){
						arrOptions = widget.getField("VRMOVIVEND").mask.params;
					}
				}*/
				arrOptions.allowZero = true;
				arrOptions.decimal = ",";
				arrOptions.defaultZero = true;
				arrOptions.precision = 2;
				arrOptions.showSymbol = false;
				stVRMOVIVEND = widget.getField('VRMOVIVEND').value();
				stVRMOVIVEND = $.currency.string(stVRMOVIVEND, arrOptions);

				currentRow.VRMOVIVEND = stVRMOVIVEND;
				widget.currentRow.VRMOVIVEND = stVRMOVIVEND;
				widget.getField('VRMOVIVEND').value(stVRMOVIVEND);
				widget.getField('VRMOVIVEND').setValue(stVRMOVIVEND);

				valorRecebimento = UtilitiesService.getFloat(widget.getField('VRMOVIVEND').value());
			}
		}

		if (widget.isValid()) {
			currentRow.VRMOVIVEND = UtilitiesService.getFloat(currentRow.VRMOVIVEND);
			widget.getField('VRMOVIVEND').setValue(currentRow.VRMOVIVEND);
			currentRow.eletronicTransacion.data.CDNSUHOSTTEF = currentRow.CDNSUHOSTTEF;
			if (self.validValue(widget.getField('VRMOVIVEND'), '')) {
				self.trataRepique(currentRow, widgetPayment, valorRecebimento, adiantamento);
			}
		}
	};

	this.trataRepique = function (currentRow, widgetPayment, valorRecebimento, adiantamento) {
		PaymentRepository.findOne().then(function (paymentData) {
				var valorRepique, valorMaximoRepique, VRPEMAXREPIQVND, fieldValorRepique;

				if (!!adiantamento && valorRecebimento >= paymentData.DATASALE.FALTANTE){
					ScreenService.showMessage('Operação bloqueada:<br><br>Não é possível adiantar o valor total da mesa.<br><br>O recebimento final precisa ser feito utilizando a função de receber mesa.');
				}
				else {
					// Algumas das parametrizações do repique já são tratadas na variável showRepique no paymentService.js
					if (paymentData.showRepique && (valorRecebimento > paymentData.DATASALE.FALTANTE) && currentRow.tiporece.IDUTCONTRREPIQ !== 'N') {
	                    currentRow.hasChange = true;
						VRPEMAXREPIQVND = UtilitiesService.getFloat(operatorData.VRPEMAXREPIQVND);
						valorMaximoRepique = Math.trunc(((VRPEMAXREPIQVND / 100) * paymentData.DATASALE.TOTAL) * 100) / 100;
						valorRepique = Math.round((valorRecebimento - paymentData.DATASALE.FALTANTE) * 100) / 100;
						self.criaWidget(widgetPayment.container,'Repique');
						fieldValorRepique = widgetPayment.container.getWidget('Repique').getField('valorRepique');

						if (operatorData.IDTPCONTRREPIQ === 'V' && currentRow.tiporece.IDUTCONTRREPIQ === 'S') {
							ScreenService.confirmMessage("Deseja alterar o valor do repique? ", 'question',
								function () {
									self.criaWidget(widgetPayment.container,'Repique');
									ScreenService.openPopup(widgetPayment.container.getWidget('Repique')).then(function(){
										fieldValorRepique.label = "Valor: (Troco: " + UtilitiesService.toCurrency(valorRepique) + ")";
										fieldValorRepique.clearValue();
									});
								}, function () {
									if (VRPEMAXREPIQVND > 0 && valorRepique > valorMaximoRepique) {
										ScreenService.showMessage('Operação bloqueada. O valor do repique excede o valor máximo possível.');
									} else {
										currentRow.REPIQUE = valorRepique;
										self.handlePaymentData(currentRow, widgetPayment, adiantamento);
									}
								}
							);
						} else {
							if (VRPEMAXREPIQVND > 0 && valorRepique > valorMaximoRepique) {
								ScreenService.showMessage('Operação bloqueada. O valor do repique excede o valor máximo possível.');
							} else {
								currentRow.REPIQUE = valorRepique;
								self.handlePaymentData(currentRow, widgetPayment, adiantamento);
							}
						}
					} else {
						self.handlePaymentData(currentRow, widgetPayment, adiantamento);
					}
				}
		});
	};

	this.alteraRepique = function (widgetRepique) {
		PaymentRepository.findOne().then(function (paymentData) {
				var VRPEMAXREPIQVND = UtilitiesService.getFloat(operatorData.VRPEMAXREPIQVND);
				self.criaWidget(widgetRepique.container,'paymentPopup');
				var paymentPopup = widgetRepique.container.getWidget('paymentPopup');
				var currentRow = _.clone(paymentPopup.currentRow);
				var valorRecebimento = UtilitiesService.getFloat(paymentPopup.getField('VRMOVIVEND').value());
				var widgetPayment = widgetRepique.container.getWidget('paymentMenu');
				var valorRepique = UtilitiesService.getFloat(widgetRepique.getField('valorRepique').value());

				valorTroco = Math.round((valorRecebimento - paymentData.DATASALE.FALTANTE) * 100) / 100;

				if (valorRepique >= 0){
					if (valorRepique <= valorTroco) {
                        currentRow.hasChange = true;
						var valorMaximoRepique = Math.trunc(((VRPEMAXREPIQVND / 100) * paymentData.DATASALE.TOTAL) * 100) / 100;
						if (VRPEMAXREPIQVND > 0 && valorRepique > valorMaximoRepique) {
							ScreenService.showMessage('Operação bloqueada. O valor do repique excede o valor máximo possível (R$ ' + UtilitiesService.toCurrency(valorMaximoRepique) + ').');
						} else {
							currentRow.REPIQUE = valorRepique;
							self.handlePaymentData(currentRow, widgetPayment);
						}
					} else {
						ScreenService.showMessage('Operação bloqueada. O valor do repique precisa ser menor ou igual ao valor do troco.');
					}
				} else {
					ScreenService.showMessage('Digite o valor do repique a ser alterado.');
				}
		});
	};

	this.handlePaymentData = function (currentRow, widgetPayment, adiantamento) {
		ScreenService.closePopup();
		ScreenService.showLoader();
		AccountSaleCode.findOne().then(function (saleCode) {
			currentRow.saleCode = saleCode;
			currentRow.adiantamento = adiantamento;
			PaymentService.handlePayment(currentRow).then(function (handlePaymentResult) {
				ScreenService.hideLoader();
				if(handlePaymentResult==undefined){
					handlePaymentResult = {error:true,message:"Erro. Transação não foi realizada."};
				}
				if (!handlePaymentResult.error) {
					self.paymentFinish(widgetPayment, handlePaymentResult.data, adiantamento);
				} else {
					self.handleSetPaymentError(handlePaymentResult);
				}
			});
		});
	};

	this.handleSetPaymentError = function (handlePaymentResult) {
		ScreenService.showMessage(handlePaymentResult.message, 'alert').then(function () {
			handlePaymentResult = handlePaymentResult.data;

			if (!_.isEmpty(handlePaymentResult) && handlePaymentResult.IDTPTEF === '5' && handlePaymentResult.errorCode === -43) {
				if(GeneralFunctions.sendSitefLog){
					GeneralFunctions.sendSitefLog();
				}
			}
		}.bind(this));
	};

	this.handleConsumerDebit = function (widget, adiantamento) {
		if (widget.currentRow.tiporece.IDTIPORECE == 'A') {
			PaymentRepository.findOne().then(function (payment) {
				var VRMOVIVEND = parseFloat(widget.currentRow.VRMOVIVEND.toString().replace(',', '.'));
				VRMOVIVEND = parseFloat(VRMOVIVEND.toFixed(2));
				if (VRMOVIVEND > payment.DATASALE.FALTANTE){
					ScreenService.showMessage('Valor do débito não pode ser maior que o valor restante da venda.');
				}
				else {
					GetConsumerLimit.findOne().then(function (limits) {
						var leftover = parseFloat((limits.SALDO_ATUAL - VRMOVIVEND).toFixed(2));
						if (limits.VRAVIDEBCONS && leftover <= limits.VRAVIDEBCONS) {
							ScreenService.showMessage('Consumidor : ' + limits.NMCONSUMIDOR + '<br>Saldo Empresa : R$ ' + UtilitiesService.toCurrency(leftover) + '<br>Favor comprar novos créditos.', 'alert').then(function () {
								self.setPayment(widget, adiantamento);
							});
						}
						else {
							self.setPayment(widget, adiantamento);
						}
					});
				}
			});
		}
		else if (widget.currentRow.tiporece.IDTIPORECE == 'W'){
			self.initWiBXInterface(widget);
		}
		else {
			self.setPayment(widget, adiantamento);
		}
	};

    this.initWiBXInterface = function (widget){
        var VRMOVIVEND = parseFloat(widget.currentRow.VRMOVIVEND.toString().replace(',', '.'));
        VRMOVIVEND = parseFloat(VRMOVIVEND.toFixed(2));
        PaymentService.convertWiBX(VRMOVIVEND).then(function (result){
            ScreenService.confirmMessage(
            'Serão descontados ' + result[0].wibxAmount + ' WiBX. Deseja continuar?', 'question',
                function () {
                    PaymentService.paymentWiBX(result[0].wibxAmount).then(function (requestResult){
						self.criaWidget(ApplicationContext.templateManager.container,'WiBXPayment');
                        var wibxWidget = widget.container.getWidget('WiBXPayment');
                        widget.currentRow.VRMOVIVEND = VRMOVIVEND;
                        wibxWidget.currentRow = widget.currentRow;
                        wibxWidget.currentRow.WiBXData = requestResult[0];
                        var wibxQrCode = requestResult[0].qrCode;
                        ScreenService.openPopup(wibxWidget).then(function (){
                            wibxWidget.getField('wibxLabel').label = "Valor sendo cobrado: R$ " + UtilitiesService.toCurrency(VRMOVIVEND);
                            var qrCodeField = document.getElementsByClassName('wibxQrCode')[0];
                            var qrcode = new QRCode(qrCodeField, {
                                width : 250,
                                height : 250
                            });
                            qrcode.makeCode(wibxQrCode);
                        });
                    });
                },
                function () {}
            );
        });
    };

    this.cancelWiBX = function(widget){
        PaymentService.cancelWiBX();
        ScreenService.closePopup();
        ScreenService.closePopup();
    };

    this.statusWiBX = function(widget){
        PaymentService.statusWiBX().then(function (result){
            if (result[0].status == 0){
                ScreenService.showMessage("A transação ainda não foi realizada. Tente novamente.");
            }
            else if (result[0].status == 1){
                ScreenService.showMessage("A transação expirou. Feche o popup e refaça a transação com uma nova tela de recebimento.");
            }
            else if (result[0].status == 2){
                ScreenService.showMessage("Transação autorizada.").then(function (){
                    self.handlePaymentData(widget.currentRow, widget.container.getWidget('paymentMenu'));
                    ScreenService.closePopup();
                });
            }
            else if (result[0].status == 3){
                ScreenService.showMessage("A transação foi cancelada.");
            }
            else {
                ScreenService.showMessage("Erro: status não-identificado.");
            }
        });
    };

	this.validValue = function (field, customMessage) {
		var value = field.value();
		value = UtilitiesService.removeCurrency(value);
		var min = field.range.min;
		var max = field.range.max;
		if(max){
			arrOptions = [];
			arrOptions.allowZero = true;
			arrOptions.defaultZero = true;
			arrOptions.precision = 2;
			arrOptions.showSymbol = false;
			max = $.currency.string(max, arrOptions);
			max = UtilitiesService.getFloat(max);
		}
		if ((value < min) || isNaN(value)) {
			ScreenService.showMessage(MESSAGE.VR_MIN, 'alert');
			field.setValue(min);
			return false;
		} else if (typeof max === 'number') {
			if (value > max) {
				ScreenService.showMessage(_.isEmpty(customMessage) ? MESSAGE.VR_MAX : customMessage, 'alert');
				field.setValue(max);
				return false;
			}
		}

		return true;
	};

	this.paymentFinish = function (widgetPayment, DATASALE, adiantamento) {
		self.attStripeData(widgetPayment);
		ScreenService.closePopup();

		if (!DATASALE.FALTANTE && !DATASALE.TROCO && !DATASALE.REPIQUE || (!!adiantamento && !DATASALE.TROCO && !DATASALE.REPIQUE)) {
			self.verifyFinishPayment(adiantamento);
		} else if(mustComplete){
			self.completePaymentWithOtherMethod();
		}
	};

	this.completePaymentWithOtherMethod = function() {
		ScreenService.confirmMessage("Deseja completar com outro forma de pagamento ? ", 'question',
			function () {
				var container = templateManager.container;
				self.criaWidget(container,'popupConsumidorBalcao');
				var popup = container.getWidget('popupConsumidorBalcao');

				self.attScreen(popup);
				self.setPaymentTypes(7, popup.container);
				mustComplete = false;
			}, function () { }
		);
	};

	this.verifyFinishPayment = function (adiantamento) {
		if(!adiantamento){
			if(!EventManager.isAvailableForExecution()){
				window.log("Impedindo a execução duplicada.");
				return;
			}
			EventManager.lockExecution();
		}
		ScreenService.showLoader();
		//Muda a mensagem para que o aguarde seja escondido automaticamente caso seja exibido uma mensagem ou um popup
		ScreenService.changeLoadingMessage("Aguarde....");
		PaymentService.getPaymentValue().then(function (DATASALE) {
			if (!DATASALE.FALTANTE || !!adiantamento) {
				PaymentRepository.findOne().then(function (payment) {
					if (!payment.CREDITOPESSOAL) {
						self.verificaEnvioCupomEmail(adiantamento);
					} else {
						PaymentService.chargePersonalCredit(payment).then(function (paymentResult) {
							if (paymentResult[0].dadosImpressao != null) {
								if(paymentResult[0].dadosImpressao.IDUTILIMPFRONT){
									var param = {};
									param.impressora = paymentResult[0].dadosImpressao.dadosImpressao;
									param.IDUTILIMPFRONT = paymentResult[0].dadosImpressao.IDUTILIMPFRONT;
									param.comandos = paymentResult[0].dadosImpressao.comandos;
									PerifericosService.print(param).then(function () {});
								} else {
									PrinterService.printerCommand(PrinterService.TEXT_COMMAND, paymentResult[0].dadosImpressao.RECEIPT);
									PrinterService.printerSpaceCommand();
									if(!_.isEmpty(PrinterService.printerCommands)) {
										PrinterService.printerInit().then(function (result) {
											if (result.error)
												ScreenService.alertNotification(result.message);
										});
									}
								}
							}
							PaymentRepository.clearAll().then(function () {
								AccountController.finishPayAccount();
							});
						});
						ScreenService.hideLoader();
					}
				}.bind(this));
			} else {
				EventManager.stop();
				ScreenService.showMessage(MESSAGE.FAIL_PAYMENT, 'alert');
				ScreenService.hideLoader();
			}
		});
	};

	this.prepareCPFPopup = function (container, adiantamento) {
		PaymentRepository.findOne().then(function (paymentData){
			var tot = paymentData.DATASALE.TOTALVENDA;
			if(paymentData.VRDESCCASHUDS > 0 ){
				//tot = tot + paymentData.VRDESCCASHUDS;
			}
			if (
				operatorData.IDSOLOBSFINVEN == 'S' ||
				operatorData.IDSOLICITACPF == 'S' ||
				(operatorData.IDCOLETOR != 'C' && operatorData.VROBRIGCPFNOTA != null && tot >= operatorData.VROBRIGCPFNOTA) ||
				operatorData.IDSOLDIGCONS == 'S' ||
				operatorData.IDINFNOMEEND == 'S'
			){
				self.criaWidget(container,'consumerCPFPopup');
				var consumerCPFPopup = container.getWidget('consumerCPFPopup');
				if(!adiantamento) {
					container.getWidget('paymentMenu').getAction('info').isVisible = true;
				} else {
					container.getWidget('advancePaymentMenu').getAction('info').isVisible = true;
				}

				consumerCPFPopup.getField('NRINSCRCONS').isVisible = operatorData.IDSOLICITACPF == 'S';
				consumerCPFPopup.getField('DSENDECONSVENDA').isVisible = operatorData.IDINFNOMEEND == 'S';
				consumerCPFPopup.getField('NOMECONS').isVisible = operatorData.IDSOLDIGCONS === 'S' || operatorData.IDINFNOMEEND == 'S';
				consumerCPFPopup.getField('NMFANVEN').isVisible = (operatorData.modoHabilitado == 'B' && operatorData.IDUTLSENHAOPER == 'C');
				consumerCPFPopup.getField("DSOBSFINVEN").isVisible = operatorData.IDSOLOBSFINVEN === 'S';

				if(!_.isEmpty(paymentData.NRCPFFIDUDS)){
					consumerCPFPopup.getField('NRINSCRCONS').isVisible = true;
				}
				consumerCPFPopup.currentRow.NRINSCRCONS = paymentData.NRINSCRCONS;
				if(_.isEmpty(consumerCPFPopup.currentRow.NRINSCRCONS)){
					consumerCPFPopup.currentRow.NRINSCRCONS = !_.isEmpty(paymentData.NRCPFFIDUDS) ? paymentData.NRCPFFIDUDS : null;
				}
				if(!_.isEmpty(consumerCPFPopup.currentRow.NRINSCRCONS)){
					consumerCPFPopup.getField('NRINSCRCONS').readOnly = true;
				} else {
					consumerCPFPopup.getField('NRINSCRCONS').readOnly = false;
				}
				consumerCPFPopup.currentRow.NOMECONS = paymentData.NOMECONS;
				consumerCPFPopup.currentRow.CDVENDEDOR = paymentData.CDVENDEDOR;
				consumerCPFPopup.currentRow.NMFANVEN = paymentData.NMFANVEN;
				consumerCPFPopup.currentRow.DSENDECONSVENDA = paymentData.DSENDECONSVENDA;
				consumerCPFPopup.currentRow.DSOBSFINVEN = paymentData.DSOBSFINVEN;

				ScreenService.openPopup(consumerCPFPopup);
			} else {
				if (container.getWidget('paymentMenu') != null){
					container.getWidget('paymentMenu').getAction('info').isVisible = false;
				}
			}
		});
	};

	this.handleShowPaymentList = function (widget, adiantamento) {
		PaymentService.findAllPayment().then(function (arrTiporece) {
			if (!_.isEmpty(arrTiporece)) {
				self.handlePaymentScreen(widget, 'paymentList');
			} else {
				ScreenService.showMessage('Lista de recebimentos está vazia.', 'alert');
			}
		});
	};

	this.handlePaymentScreen = function (widget, nameWidgetToShow) {
		// alterna entre widgets do fluxo de pagamento
		widget.isVisible = false;

		self.criaWidget(widget.container,nameWidgetToShow);
		var widgetToShow = widget.container.getWidget(nameWidgetToShow);
		if (!_.isEmpty(widgetToShow)){
			widgetToShow.isVisible = true;
			widgetToShow.activate();
		}
	};

    this.trataPagamentosIncompletos=function(){
        if(operatorData.modoHabilitado=='B'){return;}
        PaymentRepository.findOne().then(function (paymentData){
            AccountController.getAccountData(function (accountData) {
                accountData = accountData[0];
                if(paymentData){
                    accountData.posicoes = paymentData.NRLUGARMESA;
                }
                AccountService.getPayments(accountData).then(function(payments){
                    if(payments){
                        var pagamentoIncompleto = null;
                        payments.forEach(function(pagamento,index){
                            if(pagamento.IDSTATUSMOV!==undefined){
                                if(pagamento.IDSTATUSMOV=='P' && !pagamento.CDNSUTEFMOB && pagamento.NRSEQMOVMOB){
                                    pagamentoIncompleto = pagamento;
                                }
                            }
                        });
                        if(pagamentoIncompleto){
							var transacao = {};
							if(existe(window,"ZhCieloAutomation.buscaTransacao")){
								pagamentoIncompleto.valor=pagamentoIncompleto.VRMOV;
								transacao = ZhCieloAutomation.buscaTransacao(JSON.stringify(pagamentoIncompleto));
								if(typeof(transacao) === 'string' && transacao!= ""){
									transacao = JSON.parse(transacao);
								}
								transacao.nsu = transacao.cieloCode||null;
							}
							if(transacao.nsu){
								ScreenService.confirmMessage(
									'Um pagamento no valor de R$'+parseFloat(pagamentoIncompleto.VRMOV).toFixed(2).replace('.', ',') +
									' foi iniciado e não foi concluído.'+
									'<br><br>O NSU desse pagamento é '+transacao.nsu+'?',
									'question',
									function(){
										self.criaWidget(ApplicationContext.templateManager.container,'popupInformaNSUManual');
										var popup = ApplicationContext.templateManager.container.getWidget("popupInformaNSUManual");
										if(!popup){
											self.backPayment();
										} else {
											popup.getField('nsu').value(transacao.nsu);
											popup.currentRow.origem='PaymentController';
											pagamentoIncompleto.NRCOMANDA = accountData.NRCOMANDA;
											pagamentoIncompleto.NRVENDAREST = accountData.NRVENDAREST;
											pagamentoIncompleto.CDFILIAL = operatorData.CDFILIAL;
											pagamentoIncompleto.CDCAIXA = operatorData.CDCAIXA;
											pagamentoIncompleto.CDNSUHOSTTEF = transacao.nsu;
											pagamentoIncompleto.nsu = transacao.nsu;
											popup.currentRow.pagamentoIncompleto=pagamentoIncompleto;
											ScreenService.openPopup(popup);
										}
									},function(){
										ScreenService.confirmMessage(
										'<br><br>Deseja informar o NSU/DOC desse pagamento manualmente?',
										'question',
										function(){
											self.criaWidget(ApplicationContext.templateManager.container,'popupInformaNSUManual');
											var popup = ApplicationContext.templateManager.container.getWidget("popupInformaNSUManual");
											if(!popup){
												self.backPayment();
											} else {
												popup.getField('nsu').value('');
												popup.currentRow.origem='PaymentController';
												pagamentoIncompleto.NRCOMANDA = accountData.NRCOMANDA;
												pagamentoIncompleto.NRVENDAREST = accountData.NRVENDAREST;
												pagamentoIncompleto.CDFILIAL = operatorData.CDFILIAL;
												pagamentoIncompleto.CDCAIXA = operatorData.CDCAIXA;
												popup.currentRow.pagamentoIncompleto=pagamentoIncompleto;
												ScreenService.openPopup(popup);
											}
										},function(){
											self.backPayment();
										});
									}
								);
							} else{
	                            ScreenService.confirmMessage(
	                            'Um pagamento no valor de R$'+parseFloat(pagamentoIncompleto.VRMOV).toFixed(2).replace('.', ',') +
	                            ' foi iniciado e não foi concluído.'+
	                            '<br><br>Deseja informar o NSU/DOC desse pagamento manualmente?',
	                            'question',
	                            function(){
									self.criaWidget(ApplicationContext.templateManager.container,'popupInformaNSUManual');
	                                var popup = ApplicationContext.templateManager.container.getWidget("popupInformaNSUManual");
	                                if(!popup){
	                                    self.backPayment();
	                                } else {
	                                    popup.getField('nsu').value('');
	                                    popup.currentRow.origem='PaymentController';
	                                    pagamentoIncompleto.NRCOMANDA = accountData.NRCOMANDA;
	                                    pagamentoIncompleto.NRVENDAREST = accountData.NRVENDAREST;
	                                    pagamentoIncompleto.CDFILIAL = operatorData.CDFILIAL;
	                                    pagamentoIncompleto.CDCAIXA = operatorData.CDCAIXA;
	                                    popup.currentRow.pagamentoIncompleto=pagamentoIncompleto;
	                                    ScreenService.openPopup(popup);
	                                }
	                            },function(){
	                                ScreenService.confirmMessage(
	                                    'O NSU/DOC é obrigatório para este tipo de pagamento.'+
	                                    '<br>Para continuar é necessário descartar esse pagamento.'+
	                                    '<br><br>Deseja deletar o pagamento de R$'+parseFloat(pagamentoIncompleto.VRMOV).toFixed(2).replace('.', ',')+'?',
	                                    'question',
	                                    function(){
	                                        pagamentoIncompleto.NRCOMANDA = accountData.NRCOMANDA;
	                                        pagamentoIncompleto.NRVENDAREST = accountData.NRVENDAREST;
	                                        pagamentoIncompleto.CDFILIAL = operatorData.CDFILIAL;
	                                        pagamentoIncompleto.CDCAIXA = operatorData.CDCAIXA;
	                                        PaymentService.undoPayment(pagamentoIncompleto.NRSEQMOVMOB,pagamentoIncompleto).then(function(){
	                                            self.backPayment().then(function(){
	                                                //AccountController.openPayment(AccountController.allPositionsTemp);
	                                            });
	                                        });
	                                    },function(){
	                                        self.backPayment();
	                                    }
	                                );
	                            });
	                        }
                        }
                    }
                });
            });
        });
    };

	this.handleActionsPaymentStripe = function (container){
		PaymentRepository.findOne().then(function (paymentData){
			self.handleActionUDSPopup(container.getWidget("paymentMenu"));

			if (operatorData.modoHabilitado == 'B') {
				// não mostra botoes na recarga de credito
				if(_.isNumber(paymentData.VRRECARGA)){
					container.getWidget("paymentMenu").getAction("info").isVisible = false;
					container.getWidget("paymentMenu").getAction("setconsumer").isVisible = false;
					container.getWidget("paymentMenu").getAction("desconto").isVisible = false;
					container.getWidget("paymentMenu").getAction("buscarFidelidadeUDS").isVisible = false;
				}
				container.getWidget("paymentMenu").getAction("descontoTaxa").isVisible = false;
			} else {
				// não mostra botoes na recarga de credito
				if(_.isNumber(paymentData.VRRECARGA)){
					container.getWidget("paymentMenu").getAction("info").isVisible = false;
					container.getWidget("paymentMenu").getAction("desconto").isVisible = false;
					container.getWidget("paymentMenu").getAction("buscarFidelidadeUDS").isVisible = false;
				}
				container.getWidget("paymentMenu").getAction("setconsumer").isVisible = false;
				// Mostra o desconto da taxa somente se tiver recebendo a mesa inteira (sem posições selecionadas).
				container.getWidget("paymentMenu").getAction("descontoTaxa").isVisible = _.isEmpty(paymentData.NRLUGARMESA) && !_.isNumber(paymentData.VRRECARGA);
			}
			if(!PermissionService.hasAccess('cupomDesconto') && container.getWidget("paymentMenu")){
				if(container.getWidget("paymentMenu").getAction('desconto')){
					container.getWidget("paymentMenu").getAction('desconto').isVisible = false;
					container.getWidget("paymentMenu").getAction('descontoTaxa').isVisible = false;
				}
			}

			if(!PermissionService.hasAccess('escolhaConsumidor') && container.getWidget("paymentMenu")){
				if(container.getWidget("paymentMenu").getAction('setconsumer')){
					container.getWidget("paymentMenu").getAction('setconsumer').isVisible = false;
				}
			}

		});
	};

	this.handleCartaoTodoPopup = function (popup){
		popup.getField('card_number').setValue("");
		popup.getField('saldodisponivel').setValue(0);
		popup.getField('saldoutilizado').setValue(0);
		popup.getField('card_password').setValue("");
	};

	this.handlePromocoesIntPopup = function (container) {
		if(operatorData.IDUTILINTEPROMO == 'S' && (operatorData.modoHabilitado == 'M' || operatorData.modoHabilitado == 'B')){
			container.getWidget("paymentMenu").getAction("buscarPromocoesInt").isVisible = true;
			self.criaWidget(container,'popupBuscarPromocoesInt');
			var popup = container.getWidget("popupBuscarPromocoesInt");
			var buscaPromocoesIntPayment = popup.getField('buscaPromocoesIntPayment');
			var buscaPromocoesIntWallet = popup.getField('buscaPromocoesIntWallet');
			var buscaPromocoesIntOffers = popup.getField('buscaPromocoesIntOffers');
			buscaPromocoesIntPayment.value(null);
			buscaPromocoesIntPayment.clearValue();
			buscaPromocoesIntWallet.value(null);
			buscaPromocoesIntWallet.clearValue();
			buscaPromocoesIntOffers.value(null);
			buscaPromocoesIntOffers.clearValue();
		} else {
			container.getWidget("paymentMenu").getAction("buscarPromocoesInt").isVisible = false;
		}
	};

	this.handleConsumerPopupAdvance = function (popup) {
		var clientField = popup.getField('NMRAZSOCCLIE');
		var searchField = popup.getField('consumerSearch');
		var consumerField = popup.getField('NMCONSUMIDOR');

		self.clearConsumerPopup(popup);
        popup.currentRow.CPF4ALL = "";

		OperatorRepository.findOne().then(function (operatorData) {
			if (operatorData.modoHabilitado == 'B') {
				popup.container.getWidget("advancePaymentMenu").getAction("setconsumer").isVisible = true;
			} else {
				popup.container.getWidget("advancePaymentMenu").getAction("setconsumer").isVisible = false;
			}

			var permiteDig = operatorData.IDPERDIGCONS == 'S';

			clientField.readOnly = permiteDig;
			searchField.readOnly = permiteDig;
			consumerField.readOnly = permiteDig;

			popup.getAction("qrcode").isVisible = !Util.isDesktop();
		});
	};

	this.handleActionUDSPopup = function (paymentMenu) {
		// na modalidade venda mesa a UDS só pode ser consultada antes de fechar a mesa e não na tela de pagamento
		// na modalidade venda balcão a UDS só pode ser consultada na tela de pagamento.
		// por isso que ao entrar na tela de pagamento na modalidade balcão validamos o parametro e na modalidade mesa recebe false fixo
		// ao entrar na tela de recebimento e for uma recarga de crédito o botão da UDS deve receber false fixo
		if (operatorData.modoHabilitado == 'B') {
			paymentMenu.getAction("buscarFidelidadeUDS").isVisible = (operatorData.IDUTILFIDUDS == "S");
		} else {
			paymentMenu.getAction("buscarFidelidadeUDS").isVisible = false;
		}
	};

	this.attPaymentList = function (widget) {
		PaymentService.findAllPayment().then(function (arrTiporece) {
			widget.dataSource.data = _.map(arrTiporece, function (tiporece) {
				tiporece.VRMOVIVEND = UtilitiesService.toCurrency(tiporece.VRMOVIVEND);
				return tiporece;
			});

			if (_.isEmpty(widget.dataSource.data)) {
				self.handlePaymentScreen(widget, 'paymentMenu');
			}
		});
	};

	this.setPaymentRow = function (widget) {
		widget.container.getWidget('cancelPayment').currentRow = widget.currentRow;
	};

    this.removePayment = function (widget){
        if (widget.currentRow.IDTIPORECE == 'W'){
            ScreenService.confirmMessage(
                MESSAGE.ALERT_WIBX, 'question',
                function () {
                    PaymentService.handleRemovePayment(widget.currentRow).then(function (handleRemovePaymentResult) {
                        if (!handleRemovePaymentResult.error) {
							self.criaWidget(widget.container,'paymentList');
                            var widgetPaymentList = widget.container.getWidget('paymentList');
                            self.attStripeData(widgetPaymentList);
                            self.attPaymentList(widgetPaymentList);
                        } else {
                            ScreenService.showMessage(handleRemovePaymentResult.message, 'alert');
                        }
                    }.bind(this));
                },
                function () {}
            );
        }
        else {
            ScreenService.confirmMessage(
                MESSAGE.REMOVE_PAYMENT, 'question',
                function () {
                    PaymentService.handleRemovePayment(widget.currentRow).then(function (handleRemovePaymentResult) {
                        if (!handleRemovePaymentResult.error) {
							self.criaWidget(widget.container,'paymentList');
                            var widgetPaymentList = widget.container.getWidget('paymentList');
                            self.attStripeData(widgetPaymentList);
                            self.attPaymentList(widgetPaymentList);
                        } else {
                            ScreenService.showMessage(handleRemovePaymentResult.message, 'alert');
                        }
                    }.bind(this));
                },
                function () { }
            );
        }
    };

	this.attScreen = function (widget) {
		var payMenuWidget = widget.container.getWidget('paymentMenu') || widget.container.getWidget('advancePaymentMenu');
		self.attStripeData(payMenuWidget);
		ScreenService.closePopup();
		payMenuWidget.activate();
	};

	this.setConsumerInfo = function (consumerCPFInfoWidget) {
		var isValid = true;

		var NRINSCRCONS = consumerCPFInfoWidget.currentRow.NRINSCRCONS || null;
		var DSENDECONSVENDA = consumerCPFInfoWidget.currentRow.DSENDECONSVENDA || null;
		var EMAIL = null;
		var NOMECONS = consumerCPFInfoWidget.currentRow.NOMECONS || null;
		var DSOBSFINVEN = consumerCPFInfoWidget.currentRow.DSOBSFINVEN || null;
		var CDVENDEDOR = null;
		var NMFANVEN = null;
		var vendedores = _.filter(consumerCPFInfoWidget.getField('NMFANVEN').dataSource.data, function (o) { return o.__isSelected; });

		if (vendedores.length > 0) {
			CDVENDEDOR = vendedores[0].CDVENDEDOR;
			NMFANVEN = vendedores[0].NMFANVEN;
		}

		if (NRINSCRCONS) {
			NRINSCRCONS = NRINSCRCONS.replace(/[^0-9 ]/g, "");
			isValid = UtilitiesService.isValidCPForCNPJ(NRINSCRCONS);
			if (!isValid) {
				ScreenService.showMessage('CPF/CNPJ inválido.', 'alert');
				return;
			}
		}

		if (EMAIL) {
			isValid = UtilitiesService.checkEmail(EMAIL);
			if (!isValid) {
				ScreenService.showMessage('E-mail inválido.', 'alert');
				return;
			}
		}

		if (isValid) {
			PaymentRepository.findOne().then(function (paymentData) {
				paymentData.NRINSCRCONS = NRINSCRCONS;
				paymentData.DSENDECONSVENDA = DSENDECONSVENDA;
				paymentData.EMAIL = EMAIL;
				paymentData.NOMECONS = NOMECONS;
				paymentData.CDVENDEDOR = CDVENDEDOR;
				paymentData.NMFANVEN = NMFANVEN;
				paymentData.DSOBSFINVEN = DSOBSFINVEN;
				PaymentRepository.save(paymentData);
				ScreenService.closePopup();
			});
		}
	};

	this.payAccount = function (adiantamento) {
		PaymentService.payAccount(adiantamento).then(function (payAccountResult) {
			var promiseArray = Array();
			var boExecutaFuncao = true;
			if (!payAccountResult.error) {
				if (!_.isEmpty(payAccountResult.data.dadosImpressao)) {
					boExecutaFuncao = false;
					payAccountResult.data.dadosImpressao.TEFVOUCHER = [];
					promiseArray.push(
						self.imprimePedidosMaquininha(payAccountResult).then(function(){
							return self.handlePrintNote(payAccountResult);
						})
					);
				} else if (!_.isEmpty(_.get(payAccountResult, 'data.paramsImpressora'))) {
					promiseArray.push(
						self.imprimePedidosMaquininha(payAccountResult)
					);
				}
			} else {
				boExecutaFuncao = false;
				promiseArray.push(
					new Promise(function (resolve) {
						boShowMessage = true;
						if (payAccountResult.data) {
							if (payAccountResult.data.validaNrRepetida) {
								boShowMessage=false;
								self.messageLoop(payAccountResult.message);
							}
						}
						if(boShowMessage && payAccountResult.message){
							ScreenService.showMessage(payAccountResult.message, 'error');
							ScreenService.hideLoader();
						}
						resolve();
						EventManager.stop();
					})
				);
				promiseArray.push(
					new Promise(function (resolve) {
						if (_.get(payAccountResult, 'data.resetSaleCode')) {
							PaymentService.updateSaleCode();
						}
						resolve();
					})
				);
			}
			if(promiseArray.length<1){
				promiseArray.push( new Promise(function (resolve) { resolve(); }) );
			}
			return Promise.all(promiseArray).then(function(){
				if(boExecutaFuncao){ return self.payAccountFinish(payAccountResult, adiantamento); }
				self.paraTimeoutImpressao();
			});
		}.bind(this));
	};

	this.leitorRFIDAproximacao = function (widget) {
		if (_.isEmpty(widget.currentRow.CDCLIENTE)) widget.currentRow.CDCLIENTE = null;
		TableController.callLeitorRFID().then(function (infosRFID) {
			if (!infosRFID.error) {
				infosRFID = infosRFID.consumerID;
				//infosRFID.consumerID
				if (infosRFID == "") {
					ScreenService.showMessage("Não foi possível obter os dados do leitor RFID.");
				}
				else {
					self.clearConsumerPopup(widget);
					OperatorRepository.findOne().then(function (operatorData) {
						AccountService.searchConsumerRFID(operatorData.chave, widget.currentRow.CDCLIENTE, infosRFID).then(function (consumerData) {
							//ver o search consumer
							if (_.isEmpty(consumerData)) {
								ScreenService.showMessage("Não foi encontrado nenhum consumidor com este código.");
							} else {
								if (consumerData.length == 1) {
									widget.currentRow.CDCLIENTE = consumerData[0].CDCLIENTE;
									widget.currentRow.NMRAZSOCCLIE = consumerData[0].NMRAZSOCCLIE;
									widget.currentRow.CDCONSUMIDOR = consumerData[0].CDCONSUMIDOR;
									widget.currentRow.NMCONSUMIDOR = consumerData[0].NMCONSUMIDOR;
								} else {
									var consumerField = widget.getField('NMCONSUMIDOR');
									consumerField.dataSource.data = consumerData;
									consumerField.readOnly = false;
									self.modifyConsumerPopup(consumerField);
									consumerField.openField();
								}
							}
						});
					});
				}
			} else {
				ScreenService.showMessage(infosRFID.message + "<br> Tente novamente." , 'alert');
			}
		}.bind(this));
	};

	// this.callLeitorRFID = function () {
	// 	return new Promise(function (resolve) {
	// 		if (!!window.ZhStoneAutomation) {
	// 				window.rfidResult = _.bind(self.rfidResult, self, resolve);
	// 				ZhStoneAutomation.scanCardRfid();
	// 		} else {
	// 				resolve({
	// 					'error': true,
	// 					'message': 'Não foi possível chamar a integração. Sua instância não existe.'
	// 				});
	// 		}
	// 	}.bind(this));
	// };

	// this.rfidResult = function (resolve, result) {
	// 	resolve(result);
	// };


	this.messageLoop = function(msg){
		return ScreenService.showCustomDialog(msg, "alert", "exclamation", [
			{
				label: "OK",
				"default": true,
				code: function () {
					return ScreenService.confirmMessage(
						'Deseja sair do sistema?',
						"question",
						function(){ return window.location.reload(); },
						function(){ return self.messageLoop(msg); }
					);
				}
			}
		]);
	};

	this.payAccountFinish = function (payAccount, adiantamento) {
		CarrinhoDesistencia.remove(Query.build());
		ProdSenhaPed.remove(Query.build());
		var message = MESSAGE.PAYMENT_COMPLETED;

        if (_.get(payAccount, 'data.messageCurl')) {
            message += '<br><br>' + _.get(payAccount, 'data.messageCurl');
        }
		if (_.get(payAccount, 'data.IDSTATUSNFCE') === 'P') {
			message += '<br><br>' + MESSAGE.NFCE_CONTINGENCY;
		}
		if (_.get(payAccount, 'data.mensagemNfce')) {
			var retornoNfce = _.get(payAccount, 'data.mensagemNfce');
			if (!~retornoNfce.indexOf("100 - ")) {
				message += '<br><br>' + _.get(payAccount, 'data.mensagemNfce');
			}
		}
		if (_.get(payAccount, 'data.mensagemImpressao')) {
			message += '<br><br>' + _.get(payAccount, 'data.mensagemImpressao');
		}

		if (!_.isEmpty(_.get(payAccount, 'data.errPainelSenha'))) {
			ScreenService.notificationMessage(payAccount.data.errPainelSenha, 'error');
		}

		self.paraTimeoutImpressao();
		var p = Promise.resolve();
		if(message == MESSAGE.PAYMENT_COMPLETED){
			ScreenService.successNotification(message);
		} else {
			p = ScreenService.showMessage(message);
		}

		if (_.get(payAccount, 'data.IDSTMESAAUX') === 'R' && !adiantamento) {
			TableController.openAccountPayment();
		} else if(!!adiantamento) {
			AccountController.backAdvancePayment();
		} else {
			AccountController.finishPayAccount();
		}
		window.log("Finaliza pagamento da conta.");
		return p;
	};

	this.attStripeData = function (widget) {
		var stripeWidget = widget.container.getWidget('paymentStripe');

		PaymentRepository.findOne().then(function (paymentData) {
			paymentData.DATASALE=paymentData.DATASALE||{};
			paymentData.DATASALE.ANTECIPADOS = paymentData.DATASALE.ANTECIPADOS||0;
			if(!_.isEmpty(paymentData.CDCONSUMIDOR) && !_.isEmpty(paymentData.CDCLIENTE)) {
				PaymentService.getConsumerLimit(paymentData.CDCLIENTE, paymentData.CDCONSUMIDOR, 'all').then(function(limits){
					paymentData.limitDebito = limits[0].debito;
					paymentData.limitCredito = limits[0].credito;
					paymentData.IDTPVENDACONS = limits[0].IDTPVENDACONS;
					self.setValuesToStripe(stripeWidget, paymentData, paymentData.DATASALE.ANTECIPADOS, operatorData);
				});
			} else {
				self.setValuesToStripe(stripeWidget, paymentData, paymentData.DATASALE.ANTECIPADOS, operatorData);
			}
			PaymentRepository.save(paymentData);
			widget.activate();
		});
		//widget.activate();
	};

	this.setValuesToStripe = function(stripeWidget, paymentData, advancePaymentData, operatorData) {
		var amountAdvanced = 0;
		var valPago = 0;

		stripeWidget.getField('limitDebitoLabel').isVisible = _.get(paymentData, "limitDebito.LIMITE_ATUAL");
		stripeWidget.getField('limitDebito').isVisible = _.get(paymentData, "limitDebito.LIMITE_ATUAL");
		stripeWidget.getField('limitCreditoLabel').isVisible = _.get(paymentData, "limitCredito.saldoDisponivel");
		stripeWidget.getField('limitCredito').isVisible = _.get(paymentData, "limitCredito.saldoDisponivel");
		stripeWidget.getField('repiqueLabel').isVisible = _.get(paymentData, "showRepique");
		stripeWidget.getField('REPIQUE').isVisible = _.get(paymentData, "showRepique");

		advancePaymentData=advancePaymentData||0;

		if(!_.isEmpty(advancePaymentData)){
			if(!isNaN(parseFloat(advancePaymentData))){
				//soma dos adiantamentos é adicionada aos valores pagos
                amountAdvanced += parseFloat(advancePaymentData);
			}
        }

        if(!_.isEmpty(amountAdvanced)) valPago = paymentData.DATASALE.VALORPAGO+amountAdvanced;
        else valPago = paymentData.DATASALE.VALORPAGO;

		stripeWidget.currentRow = {
			TOTALVENDA: UtilitiesService.toCurrency(paymentData.DATASALE.TOTALVENDA),
			VALORPAGO: UtilitiesService.toCurrency(valPago),
			FALTANTE: UtilitiesService.toCurrency(paymentData.DATASALE.FALTANTE),
			TROCO: UtilitiesService.toCurrency(paymentData.DATASALE.TROCO),
			REPIQUE: UtilitiesService.toCurrency(UtilitiesService.removeCurrency((_.get(paymentData, "DATASALE.REPIQUE", 0)) || 0)),
			limitDebito: UtilitiesService.toCurrency(UtilitiesService.removeCurrency((_.get(paymentData, "limitDebito.LIMITE_ATUAL", 0)) || 0)),
			limitCredito: UtilitiesService.toCurrency(UtilitiesService.removeCurrency((_.get(paymentData, "limitCredito.saldoDisponivel", 0)) || 0))
		};
		if(paymentData.CDCONSUMIDOR != "" && paymentData.CDCLIENTE != ""){
			self.showBasicoExtra(paymentData, stripeWidget);
		} else {
			if (stripeWidget.getField('saldoBasicoDia').isVisible != null) stripeWidget.getField('saldoBasicoDia').isVisible = false;
			if (stripeWidget.getField('saldoExtraMes') != null) stripeWidget.getField('saldoExtraMes').isVisible = false;
			if (stripeWidget.getField('saldoBasico').isVisible != null) stripeWidget.getField('saldoBasico').isVisible = false;
			if (stripeWidget.getField('saldoExtra').isVisible != null) stripeWidget.getField('saldoExtra').isVisible = false;
		}
		return Promise.resolve();
	};

	this.initButtons = function () {
		var container = window.ApplicationContext.templateManager.container;
		var paymentGroupType = container.getWidget('categories');

		PaymentRepository.findOne().then(function (paymentData) {
			if (_.isEmpty(paymentData.IDTPVENDACONS) || paymentData.CREDITOPESSOAL) {
				ParamsGroupPriceChart.findAll().then(function (paymentGroups) {
					ParamsPriceChart.findAll().then(function (paymentTypes) {
						GroupPriceChart.save(paymentGroups).then(function () {
							PriceChart.save(paymentTypes).then(function () {
								paymentGroupType.reload();
							});
						});
					});
				});
			} else {
				self.setPaymentTypes(paymentData.IDTPVENDACONS, container);
			}
		});
	};

	this.doCancelForSale = function (widget, adiantamento, integrations) {
        PaymentService.handleCancelForSale(integrations.data).then(function (handleCancelForSaleResult) {
            if (!handleCancelForSaleResult.error) {
                self.backPayment();
            } else {
                if(!adiantamento) self.attStripeData(widget.container.getWidget('paymentMenu'));
                else self.attStripeData(widget.container.getWidget('advancePaymentMenu'));

                ScreenService.showMessage(handleCancelForSaleResult.message, 'alert');
                window.log("Erro no cancelamento: " + handleCancelForSaleResult.message);
            }
        });
    };

	this.validateStoneID = function (widget) {
	    PaymentService.findIntegrations().then(function (integrations) {
	    	PaymentRepository.findOne().then(function (paymentData) {
	    	    var valueStoneIds = widget.getField('stoneid').value();
        	    var stoneIDs = valueStoneIds.split(',');
        	    const ids = Array();
        	    var validaId = 0;
        	    integrations.data.forEach((id)=> {
        	        ids.push(id.TRANSACTIONID);
        	        window.log("Transação a ser cancelada: " + id.TRANSACTIONID);
        	    });
        	    if(!_.isEmpty(stoneIDs)){
        	        if(stoneIDs.length == integrations.data.length){
        	            stoneIDs.forEach((idStone)=> {
        	                window.log("Transação digitada: " + idStone);
        	                if(ids.includes(idStone)){
        	                    validaId++;
        	                }
        	            });

                    	if(validaId == integrations.data.length){
                    	    integrations.data = _.filter(integrations.data, function(payment){
                    	        //deixa somente os pagamentos de verdade
                    	    	payment.IDTPTEF = payment.IDTPTEF||operatorData.IDTPTEF;
                    	    	payment.NRCOMANDA = paymentData.NRCOMANDA||'';
                    	    	payment.NRVENDAREST = paymentData.NRVENDAREST||'';
                    	    	return (
                    	    	    payment.CDNSUHOSTTEF && payment.CDTIPORECE &&
                    	    		payment.IDTIPORECE && payment.IDTPTEF &&
                    	    		payment.VRMOVIVEND && payment.IDSTATUSMOV!='P'
                    	    	);
                    	    });
                    	    if ((integrations.data||[]).length<=0) {
                    	        return self.backPayment();
                    	    }
                    	    self.doCancelForSale(widget, false, integrations);
                    	} else {
                    	    ScreenService.showMessage(MESSAGE.ERRO_VALIDATE_ID, 'alert');
                    	}
                	} else {
                    	ScreenService.showMessage(MESSAGE.ERRO_VALIDATE_ID, 'alert');
                	}
            	} else {
                	ScreenService.showMessage(MESSAGE.ERRO_VALIDATE_ID, 'alert');
            	}
        	});
        });
    };

    this.cancelForSale = function (widget, adiantamento) {
        // cancela venda
        PaymentService.findIntegrations().then(function (integrations) {
            PaymentRepository.findOne().then(function (paymentData) {
                var WiBXPayments = _.filter(paymentData.TIPORECE, function(payment){
                    return payment.IDTIPORECE == 'W';
                });

                if (_.isEmpty(WiBXPayments)){
                    if (integrations.error) {
                        self.backPayment();
                    } else {
						integrations.data = _.filter(integrations.data, function(payment){
							//deixa somente os pagamentos de verdade
							payment.IDTPTEF = payment.IDTPTEF||operatorData.IDTPTEF;
							payment.NRCOMANDA = paymentData.NRCOMANDA||'';
							payment.NRVENDAREST = paymentData.NRVENDAREST||'';
							return (
								payment.CDNSUHOSTTEF && payment.CDTIPORECE &&
								payment.IDTIPORECE && payment.IDTPTEF &&
								payment.VRMOVIVEND && payment.IDSTATUSMOV!='P'
							);
						});
						if ((integrations.data||[]).length<=0) {
							return self.backPayment();
						}
                        ScreenService.confirmMessage(
                            MESSAGE.CANCEL_INTEGRATION, 'question',
                            function () {
                                window.log("Opção selecionada: SIM");
                                PermissionService.checkAccess('cancelaCupom').then(function(CDSUPERVISOR){
                                    window.log("Validado CDSUPERVISOR: " + CDSUPERVISOR);
                                    if(!!window.ZhStoneAutomation) {
                                        self.criaWidget(widget.container,'popupInformaIdCancel');
                                        popupInformaIdCancel = widget.container.getWidget('popupInformaIdCancel');
                                	    ScreenService.openPopup(popupInformaIdCancel);
                                	} else {
                                        self.doCancelForSale(widget, adiantamento, integrations);
                                    }

                                }.bind(this));

                            },
                            function () {
								if(operatorData.modoHabilitado!='B'){
								    window.log("Opção selecionada: NAO");
									self.backPayment();
								}
							}
                        );
                    }
                }
                else {
                    ScreenService.confirmMessage(
                        MESSAGE.BACK_WIBX, 'question',
                        function (){
                            if (integrations.error) {
                                self.backPayment();
                            } else {
                                ScreenService.confirmMessage(
                                    MESSAGE.CANCEL_INTEGRATION, 'question',
                                    function () {
                                        PaymentService.handleCancelForSale(integrations.data).then(function (handleCancelForSaleResult) {
                                            if (!handleCancelForSaleResult.error) {
                                                self.backPayment();
                                            } else {
                                                if(!adiantamento) self.attStripeData(widget.container.getWidget('paymentMenu'));
                                    			else self.attStripeData(widget.container.getWidget('advancePaymentMenu'));
                                                ScreenService.showMessage(handleCancelForSaleResult.message, 'alert');
                                            }
                                        });
                                    }.bind(this),
                                    function () { }
                                );
                            }
                        },
                        function () { }
                    );
                }
            }.bind(this));
        });
    };

	this.backPayment = function () {
		PaymentService.clearPayment();
		return ScreenService.goBack();
	};

	this.openDiscount = function (paymentWidget, flag){ // Flag para controlar se o desconto é no valor total ou só na taxa (modo mesa).
		PaymentService.handleOpenDiscount().then(function (handleOpenDiscountResult) {
			if (!handleOpenDiscountResult.error) {
				PermissionService.checkAccess('cupomDesconto').then(function (CDSUPERVISOR) {
					var discountPopup = null;
					if (flag){
						self.criaWidget(paymentWidget.container,'taxDiscountPopup');
						discountPopup = paymentWidget.container.getWidget('taxDiscountPopup');
					} else {
						self.criaWidget(paymentWidget.container,'discountPopup');
						if(self.limpadesconto){
							self.limpadesconto = false;
							AccountController.limpaDesconto(paymentWidget.container.getWidget('discountPopup'));
						}
						discountPopup = paymentWidget.container.getWidget('discountPopup');
					}
					discountPopup.currentRow.CDSUPERVISORd = CDSUPERVISOR;
					ScreenService.openPopup(discountPopup);
				});
			} else {
				ScreenService.showMessage(MESSAGE.BLOCK_DISCOUNT, 'alert');
			}
		});
	};

	this.clearConsumerPopup = function (popup) {
		popup.currentRow.CDCLIENTE = "";
		popup.currentRow.NMRAZSOCCLIE = "";
		popup.currentRow.CDCONSUMIDOR = "";
		popup.currentRow.NMCONSUMIDOR = "";
		if(popup.currentRow.CPFUDS){popup.currentRow.CPFUDS = "";}
		if(popup.getField('CPFUDS')){ popup.getField('CPFUDS').clearValue(); }
		if(popup.getField('NMRAZSOCCLIE')){ popup.getField('NMRAZSOCCLIE').clearValue(); }
		if(popup.getField('consumerSearch')){ popup.getField('consumerSearch').clearValue(); }
		if(popup.getField('NMCONSUMIDOR')){ 
			popup.getField('NMCONSUMIDOR').clearValue();
			if(popup.getField('NMCONSUMIDOR').dataSourceFilter){
				for (var index2 = 0; index2 < popup.getField('NMCONSUMIDOR').dataSourceFilter.length; index2++) {
					popup.getField('NMCONSUMIDOR').dataSourceFilter[index2].value = '';
				}
			}
		}
	};

    this.checkOpenConsumer = function(container){
        return PermissionService.checkAccess('escolhaConsumidor').then(function (CDSUPERVISOR){
			self.criaWidget(container,'popupConsumidorBalcao');
			var popup = container.getWidget('popupConsumidorBalcao');

			self.clearConsumerPopup(popup);

			popup.currentRow.CPF4ALL = "";
			var permiteDig = operatorData.IDPERDIGCONS == 'S';

			popup.getField('NMRAZSOCCLIE').readOnly = permiteDig;
			popup.getField('consumerSearch').readOnly = permiteDig;
			popup.getField('NMCONSUMIDOR').readOnly = permiteDig;

			popup.getAction("qrcode").isVisible = !Util.isDesktop();

        });
    };

    this.openPopupConsumidor = function (container){
		self.checkOpenConsumer(container).then(function(){
		PaymentService.findAllPayment().then(function (payments){
		ParamsClientRepository.findAll().then(function (clients) {
			if (!_.isEmpty(payments)){
				ScreenService.showMessage("Não é possível informar o consumidor com recebimentos lançados.");
				return;
			}
			var popup = container.getWidget('popupConsumidorBalcao');
			for (var index = 0; index < popup.fieldGroups.length; index++) {
				if(!popup.fieldGroups[index].name){continue;}
				if(popup.fieldGroups[index].name != '4ALL'){continue;}
				popup.fieldGroups[index].isVisible = operatorData.IDUTILFID4ALL == "S";
				break;
			}
				PaymentRepository.findOne().then(function (paymentData){

					self.clearConsumerPopup(popup);

					if (paymentData.CDCONSUMIDOR) {
						popup.currentRow.CDCONSUMIDOR = paymentData.CDCONSUMIDOR;
						popup.currentRow.NMCONSUMIDOR = paymentData.NMCONSUMIDOR;
						popup.getField('NMCONSUMIDOR').setValue(paymentData.NMCONSUMIDOR);
					}
					if (paymentData.CDCLIENTE) {
						popup.currentRow.CDCLIENTE = paymentData.CDCLIENTE;
						popup.currentRow.NMRAZSOCCLIE = paymentData.NMRAZSOCCLIE;
						popup.getField('NMRAZSOCCLIE').setValue(paymentData.NMRAZSOCCLIE);
					} else if ( clients.length > 0) {
						//se não tiver cliente informado, busca o cliente padrao
						if(operatorData.CDCLIENTE){
							for (var index = 0; index < clients.length; index++) {
								if(operatorData.CDCLIENTE==clients[index].CDCLIENTE || index == 0){
									popup.currentRow.CDCLIENTE = clients[index].CDCLIENTE;
									popup.currentRow.NMRAZSOCCLIE = clients[index].NMRAZSOCCLIE;
									popup.getField('NMRAZSOCCLIE').setValue(clients[index].NMRAZSOCCLIE);
								}
							}
						}
					}
					ScreenService.openPopup(popup);
				});
		});
		});
		});
    };

	this.openPopupFidelidadeUDS = function (container){
		self.criaWidget(container,'popupBuscarFidelidadeUDS');
		var popup = container.getWidget('popupBuscarFidelidadeUDS');
        PaymentService.findAllPayment().then(function (payments){
			if (!_.isEmpty(payments)){
				ScreenService.showMessage("Não é possível informar o consumidor com recebimentos lançados.");
				return;
			}
			PaymentRepository.findOne().then(function (paymentData){
				if(paymentData.NRCPFFIDUDS){
					popup.currentRow.CPFUDS = paymentData.NRCPFFIDUDS;
					popup.getAction('btnConfirmar').isVisible = false;
					popup.getAction('btnCancelar').isVisible = true;
					popup.getField('CPFUDS').readOnly = true;
					popup.getField('VRDESCCASHUDS').isVisible = true;
					popup.getField('VRDESCCASHUDS').value(0);
					popup.getField('VRDESCCASHUDS').label='Desconto aplicado';
					var valor = String((paymentData.VRDESCCASHUDS||0));
					valor=parseFloat(valor.replace(',', '.'));
					valor=UtilitiesService.formatFloat(valor);
					popup.getField('VRDESCCASHUDS').value(valor);
				} else {
					popup.getField('CPFUDS').value(null);
					popup.getField('CPFUDS').clearValue();
					popup.getField('VRDESCCASHUDS').isVisible = false;
					popup.currentRow.fidelitySet = false;
					popup.getAction('btnConfirmar').isVisible = true;
					popup.getAction('btnConfirmar').label = 'Buscar';
					popup.getAction('btnCancelar').isVisible = false;
					popup.getField('CPFUDS').readOnly = false;
				}
				ScreenService.openPopup(popup);
			});
        });
    };

	this.consultaFidelidadeUDS = function(widget){
        if(widget.getAction('btnConfirmar').label=='Confirmar'){
            return self.confirmaFidelidadeUDS(widget);
        }
        if (widget.currentRow.fidelitySet){
            ScreenService.showMessage('Já foi configurado um desconto de fidelidade para esta mesa. Favor remova-o antes de continuar.');
            return;
        }
        var stCPF = widget.currentRow.CPFUDS;
        if (_.isEmpty(stCPF)){
            ScreenService.showMessage('Por favor informe um CPF antes de continuar.');
            return;
        }
        stCPF = stCPF.replace(/[^0-9 ]/g, "");
        if (!UtilitiesService.isValidCPForCNPJ(stCPF)){
            ScreenService.showMessage('CPF inválido.', 'alert');
            return;
        }
        widget.currentRow.CPFUDS = stCPF;
        widget.getField('VRDESCCASHUDS').isVisible = false;
        widget.getAction('btnConfirmar').label='Buscar';
        	PaymentRepository.findOne().then(function (paymentData){
	        	AccountService.consultaFidelidadeUDS(
	        		widget.currentRow.CPFUDS,
					paymentData.DATASALE.TOTAL,
					operatorData.CDFILIAL,
					null,
					null,
					(paymentData.CDCLIENTE||operatorData.CDCLIENTE),
	        		paymentData.CDCONSUMIDOR
	        		).then(function (retConsultaFidelidadeUDS){
	                ((paymentData)?
	                    ApplicationContext.PaymentController.removeDesconto({'CDSUPERVISORd':paymentData.desconto.CDSUPERVISOR}):
	                    (function(){ return new Promise.resolve(true); })()
	                ).then(function (){
	                    retConsultaFidelidadeUDS= retConsultaFidelidadeUDS[0];
						retConsultaFidelidadeUDS.erro = (retConsultaFidelidadeUDS.erro||retConsultaFidelidadeUDS.error||true);
						if(retConsultaFidelidadeUDS.success == false && retConsultaFidelidadeUDS.message){
	                        //widget.currentRow.CPFUDS=null;
							ScreenService.showMessage(retConsultaFidelidadeUDS.message, "alert");
	                        //return;
						} else if(retConsultaFidelidadeUDS.bloqueado && retConsultaFidelidadeUDS.saldoDisp != 0){
							retConsultaFidelidadeUDS.saldoDisp = 0;
							ScreenService.showMessage("Saldo não liberado.", "alert");
						} else if(!retConsultaFidelidadeUDS.bloqueado && retConsultaFidelidadeUDS.saldoDisp > 0){
							stVSALDODISP = (parseFloat(retConsultaFidelidadeUDS.saldoDisp)).toFixed(2).replace('.', ',');
							ScreenService.showMessage("Saldo de R$"+stVSALDODISP+" disponível para uso.", "alert");
						} else if(retConsultaFidelidadeUDS.saldoDisp == 0){
							ScreenService.showMessage("Cliente sem saldo.", "alert");
						} else if(retConsultaFidelidadeUDS.clienteFidelidade === false){
							ScreenService.showMessage("Cliente não participa do programa.", "alert");
	                    } else if(retConsultaFidelidadeUDS.message && retConsultaFidelidadeUDS.erro  && !retConsultaFidelidadeUDS.success ){
	                        ScreenService.showMessage("Não foi possível estabelecer uma conexão com o servidor da UDS para consultar o cashback. Tente novamente.", "alert");
							//return;
	                    }
						retConsultaFidelidadeUDS.saldoDisp = retConsultaFidelidadeUDS.saldoDisp||0;
	                    stVSALDODISP = (parseFloat(retConsultaFidelidadeUDS.saldoDisp)).toFixed(2).replace('.', ',');
	                    widget.getField('VRDESCCASHUDS').label='Saldo disponível';
	                    widget.getField('VRDESCCASHUDS').isVisible = true;
	                    widget.getField('VRDESCCASHUDS').value(stVSALDODISP);
	                    widget.currentRow.fidelityDetails = retConsultaFidelidadeUDS;
	                    widget.currentRow.VRDESCCASHUDS = stVSALDODISP;
	                    widget.getAction('btnConfirmar').label='Confirmar';
	                    widget.getField('CPFUDS').readOnly = true;
	                });
	            });
	        });
    };

    // Funcao que executa depois que confirma o codigo promocional no modo mesa.
    this.confirmaFidelidadeUDS = function(widget){
        PaymentRepository.findOne().then(function (paymentData){
			var TOTALCASHBACK =  parseFloat(widget.getField('VRDESCCASHUDS').value());
			var SALDOAPLICADO =  TOTALCASHBACK;
			SALDOAPLICADO = Math.round(SALDOAPLICADO*100)/100;
			var totalCost = paymentData.DATASALE.TOTALVENDA;
			totalCost = Math.round(totalCost * 100) / 100;
			var minCost = 0.01 * paymentData.numeroProdutos;
			var maxDiscount = Math.round((totalCost - minCost) * 100) / 100;
			if (SALDOAPLICADO > maxDiscount){
				SALDOAPLICADO = maxDiscount;
			}
			paymentData.DATASALE.CPFUDS = widget.currentRow.CPFUDS;
			paymentData.NRCPFFIDUDS = widget.currentRow.CPFUDS;

			var promessa = function(){
				paymentData.VRDESCFID = paymentData.VRDESCFID||0;
				paymentData.VRDESCCASHUDS = SALDOAPLICADO;
				paymentData.DATASALE.TOTALVENDA = paymentData.DATASALE.TOTALVENDA - SALDOAPLICADO /*- paymentData.VRDESCFID*/;
				paymentData.DATASALE.TOTALVENDA  = Math.round(paymentData.DATASALE.TOTALVENDA * 100) / 100;
				paymentData.DATASALE.FALTANTE = paymentData.DATASALE.FALTANTE - SALDOAPLICADO /*- paymentData.VRDESCFID*/;
				paymentData.DATASALE.FALTANTE  = Math.round(paymentData.DATASALE.FALTANTE * 100) / 100;
				PaymentRepository.save(paymentData).then(function (){
						ApplicationContext.PaymentController.attScreen(widget);
						ScreenService.closePopup(true);
				});
			};
			if (SALDOAPLICADO > 0){
				ScreenService.confirmMessage(
					'O consumidor ' + (widget.currentRow.fidelityDetails.userInfo.name||'') + ' possui um saldo de R$ ' + TOTALCASHBACK.toFixed(2).replace('.', ',') + ' no programa de fidelidade. Deseja utiliza-lo como desconto na compra?',
					'question',
					function () {
						return promessa();
					},
					function () {
						SALDOAPLICADO = 0;
						return promessa();
					}
				);
			} else {
				SALDOAPLICADO = 0;
				promessa();
			}
        });
    };

	this.cancelaFidelidadeUDS = function(widget){
        PaymentRepository.findOne().then(function (paymentData){
			paymentData.VRDESCCASHUDS = paymentData.VRDESCCASHUDS||0;
			paymentData.DATASALE.TOTALVENDA = paymentData.DATASALE.TOTALVENDA+paymentData.VRDESCCASHUDS;
			paymentData.DATASALE.FALTANTE = paymentData.DATASALE.FALTANTE+paymentData.VRDESCCASHUDS;
			paymentData.DATASALE.CPFUDS = null;
			paymentData.VRDESCCASHUDS = null;
			paymentData.NRCPFFIDUDS = null;
			PaymentRepository.save(paymentData).then(function (){
				widget.getField('VRDESCCASHUDS').value(null);
				widget.getField('VRDESCCASHUDS').clearValue();
				widget.getField('CPFUDS').value(null);
				widget.getField('CPFUDS').clearValue();
				widget.currentRow.CPFUDS=null;
				widget.currentRow.VRDESCCASHUDS=null;
					ApplicationContext.PaymentController.attScreen(widget);
					ScreenService.closePopup(true);
			});
        });
    };

	this.modifyConsumerPopup = function (consumerField){
		consumerField.dataSourceFilter = [];
		consumerField.dataSourceFilter[0] = {};
		consumerField.dataSourceFilter[0].name = "CDCLIENTE";
		consumerField.dataSourceFilter[0].value = consumerField.widget.currentRow.CDCLIENTE;
		consumerField.dataSourceFilter[0].operator = "=";
		consumerField.dataSourceFilter[1] = {};
		consumerField.dataSourceFilter[1].name = "CDCONSUMIDOR";
		consumerField.dataSourceFilter[1].value = consumerField.widget.currentRow.CDCONSUMIDOR;
		consumerField.dataSourceFilter[1].operator = "=";
		if(!consumerField.value()){
			consumerField.reload();
		} else if(consumerField.value()){
			consumerField.dataSource.data = [consumerField.widget.currentRow];
			consumerField.multiplosconsumidores = [consumerField.widget.currentRow];
			consumerField.dataSourceFilter[0].value = "ignorarChamada";
		}
	};

	this.setAccountConsumer = function (popup, clear){
			if (_.isEmpty(popup.currentRow.CDCLIENTE) || clear){
				popup.currentRow.CDCLIENTE = null;
				popup.currentRow.NMRAZSOCCLIE = null;
			}
			if (_.isEmpty(popup.currentRow.CDCONSUMIDOR) || clear){
				popup.currentRow.CDCONSUMIDOR = null;
				popup.currentRow.NMCONSUMIDOR = null;
			}

			// Valida se o CPF foi digitado.
			if (clear) popup.currentRow.CPF4ALL = null;
			if (!_.isEmpty(popup.currentRow.CPF4ALL)){
				popup.currentRow.CPF4ALL = popup.currentRow.CPF4ALL.replace(/[^0-9 ]/g, "");
				if (!UtilitiesService.isValidCPForCNPJ(popup.currentRow.CPF4ALL)){
					ScreenService.showMessage('CPF inválido.', 'alert');
					return;
				}
			}
			var validaSenha = new Promise(function(resolve){ resolve(); });
			if(
				popup.currentRow.IDSOLSENHCONS == 'S' &&
				popup.currentRow.CDSENHACONSMD5 !== null &&
				!clear
			){
				validaSenha = PermissionService.promptConsumerPassword(
					popup.currentRow.CDCLIENTE,
					popup.currentRow.CDCONSUMIDOR
				);
			}
			validaSenha.then(function(result){
					PaymentRepository.findOne().then(function (paymentData) {
						PaymentService.updateCartPrices(operatorData.chave, paymentData.ITEMVENDA, popup.currentRow.CDCLIENTE, popup.currentRow.CDCONSUMIDOR, popup.currentRow.CPF4ALL, popup.currentRow.CPFUDS).then(function (result) {
							paymentData.ITEMVENDA = result.CartPricesRepository;
							paymentData.VRDESCCASHUDS = paymentData.VRDESCCASHUDS||0;
							paymentData.DATASALE.TOTALVENDA = result.nothing.valorVenda - paymentData.VRDESCCASHUDS;
							paymentData.DATASALE.TOTAL = result.nothing.totalVenda;
							paymentData.DATASALE.TOTALSUBSIDY = result.nothing.subsidioTotal;
							paymentData.DATASALE.REALSUBSIDY = result.nothing.subsidioReal;
							paymentData.DATASALE.FALTANTE = result.nothing.valorVenda - paymentData.VRDESCCASHUDS;
							paymentData.DATASALE.VRDESCONTO = 0;
							paymentData.DATASALE.PCTDESCONTO = '0';
							paymentData.DATASALE.TIPODESCONTO = 'P';
							paymentData.DATASALE.fidelityDetails = null;
							paymentData.DATASALE.FIDELITYDISCOUNT = 0;
							paymentData.DATASALE.cashbackUsed4ALL = 0;
							paymentData.DATASALE.FIDELITYVALUE = 0;
							paymentData.DATASALE.CPF4ALL = null;
							paymentData.DATASALE.CODPROMO = null;
							paymentData.numeroProdutos = result.nothing.numeroProdutos;
							paymentData.CDCLIENTE = popup.currentRow.CDCLIENTE;
							paymentData.NMRAZSOCCLIE = popup.currentRow.NMRAZSOCCLIE;
							paymentData.CDCONSUMIDOR = popup.currentRow.CDCONSUMIDOR;
							paymentData.NMCONSUMIDOR = popup.currentRow.NMCONSUMIDOR;
							paymentData.DSEMAILCONS = popup.currentRow.DSEMAILCONS;
							paymentData.descontoPromocoesIntPayment = null;
							paymentData.descontoPromocoesIntWallet = null;
							paymentData.descontoPromocoesIntOffers = null;

							PaymentRepository.save(paymentData).then(function (){
								self.attScreen(popup);
								self.setPaymentTypes(result.nothing.IDTPVENDACONS, popup.container);
								if (!_.isEmpty(result.ConsumerBalanceRepository)){
									AccountController.openBalconyFidelity(popup, result.ConsumerBalanceRepository);
								}
							});
						});
					});
				});
	};

	this.getDiscount = function (discountPopup) {
		var VRDESCONTO = 0;
		var TIPODESCONTO = '';
		// seta desconto já inserido
		PaymentService.getPaymentValue().then(function (DATASALE) {
			TIPODESCONTO = DATASALE.TIPODESCONTO;
			VRDESCONTO = TIPODESCONTO === 'P' ? DATASALE.PCTDESCONTO : DATASALE.VRDESCONTO;

			discountPopup.getField('TIPODESCONTO').setValue(TIPODESCONTO);
			discountPopup.getField('VRDESCONTO').setValue(VRDESCONTO);
			self.handleDiscountRadioChange(discountPopup);
		});
	};

	this.getTaxDiscount = function (discountPopup) {
		var VRDESCONTO = 0;
		var TIPODESCONTO = '';
		// seta desconto já inserido
		PaymentService.getPaymentValue().then(function (DATASALE) {
			TIPODESCONTO = DATASALE.TIPODESCONTOTAX;
			VRDESCONTO = TIPODESCONTO === 'P' ? DATASALE.PCTDESCONTOTAX : DATASALE.VRDESCONTOTAX;

			discountPopup.getField('TIPODESCONTOTAX').setValue(TIPODESCONTO);
			discountPopup.getField('VRDESCONTO').setValue(VRDESCONTO);
			self.handleTaxDiscountRadioChange(discountPopup);
		});
	};

	this.handleDiscountRadioChange = function (discountPopup) {
		PaymentRepository.findOne().then(function(paymentData){
		PaymentService.getPaymentValue().then(function (DATASALE) {
				total = DATASALE.TOTAL;
				minimo = (0.01 * paymentData.numeroProdutos);
			if (discountPopup.getField('TIPODESCONTO').value() === 'P') {
				discountPopup.getField('VRDESCONTO').label = 'Porcentagem';
					max = 100 * ( (total-minimo) / total );
					ApplicationContext.UtilitiesService.truncValue(max);
					arrOptions = [];
					arrOptions.allowZero = true;
					arrOptions.defaultZero = true;
					arrOptions.precision = 2;
					arrOptions.showSymbol = false;
					max = $.currency.string(max, arrOptions);
					max = UtilitiesService.getFloat(max);
					discountPopup.getField('VRDESCONTO').range.max = max ;
			} else if (discountPopup.getField('TIPODESCONTO').value() === 'V') {
				discountPopup.getField('VRDESCONTO').label = 'Valor';
					discountPopup.getField('VRDESCONTO').range.max = total - minimo;
			}
		});
		});
	};

	this.handleTaxDiscountRadioChange = function (discountPopup) {
		PaymentService.getPaymentValue().then(function (DATASALE) {
			if (discountPopup.getField('TIPODESCONTOTAX').value() === 'P') {
				discountPopup.getField('VRDESCONTO').label = 'Porcentagem';
				discountPopup.getField('VRDESCONTO').range.max = 100;
			} else if (discountPopup.getField('TIPODESCONTOTAX').value() === 'V') {
				discountPopup.getField('VRDESCONTO').label = 'Valor';
				discountPopup.getField('VRDESCONTO').range.max = DATASALE.VRTXSEORIG;
			}
		});
	};

	this.setDiscount = function (discountPopup) {
		if (discountPopup.isValid()) {
				PaymentRepository.findOne().then(function(payment){
					var setDiscount_ = function(discountPopup){
						customMessage = self.getMaxDiscountMessage(payment);
							if (self.validValue(discountPopup.getField('VRDESCONTO'), customMessage)) {
								var currentRow = discountPopup.currentRow;
								currentRow.VRDESCONTO = UtilitiesService.getFloat(currentRow.VRDESCONTO);
								PaymentService.handleApplyDiscount(currentRow).then(function (handleApplyDiscountResult) {
									if (!handleApplyDiscountResult.error) {
										self.attScreen(discountPopup);
									} else {
										ScreenService.showMessage(customMessage, 'alert');
									}
								});
							}
					};
					if(payment.NRCPFFIDUDS && payment.VRDESCCASHUDS > 0){
						ScreenService.showMessage("Operação bloqueada. Não é permitido acumular descontos. Já existe um desconto fidelidade para esta venda.", 'alert');
					} else if(
						(payment.descontoPromocoesIntPayment||null) ||
						(payment.descontoPromocoesIntWallet ||null) ||
						((payment.descontoPromocoesIntOffers||null) && operatorData.modoHabilitado=='B')
					){
						ScreenService.showMessage("Operação bloqueada. Não é permitido acumular descontos. Já existe uma promoção ativa para esta venda.", 'alert');
						/*ScreenService.confirmMessage( MESSAGE.REMOVE_DISCOUNT_PROMOCOESINT, 'question',
							function(){
								setDiscount_(discountPopup);
							},
							function(){}
						);*/
					} else {
						setDiscount_(discountPopup);
					}
				});
		}
	};

	this.setTaxDiscount = function (discountPopup){
		PaymentRepository.findOne().then(function (paymentData){
			if (discountPopup.isValid()){
				if (self.validValue(discountPopup.getField('VRDESCONTO'))){
					var currentRow = discountPopup.currentRow;

					currentRow.VRDESCONTO = UtilitiesService.getFloat(currentRow.VRDESCONTO);
					PaymentService.handleApplyTaxDiscount(currentRow).then(function (handleApplyDiscountResult){
						if (!handleApplyDiscountResult.error){
							self.attScreen(discountPopup);
						} else {
							ScreenService.showMessage('Valor do desconto não pode ser maior que o valor da taxa de serviço (R$ ' + UtilitiesService.toCurrency(paymentData.DATASALE.VRTXSEVENDA) + ').', 'alert');
						}
					});
				}
			}
		}.bind(this));
	};

	this.cancelTaxDiscount = function (discountPopup){
		if (discountPopup.isValid()){
			var currentRow = discountPopup.currentRow;

			currentRow.VRDESCONTO = 0;
			currentRow.TIPODESCONTO = 'V';
			PaymentService.handleApplyTaxDiscount(currentRow).then(function (handleApplyDiscountResult){
				self.attScreen(discountPopup);
			});
		}
	};

	this.getMaxDiscountMessage = function (paymentData) {
		var temTaxa = '.';
		if(!isNaN(paymentData.DATASALE.VRTXSEVENDA) && paymentData.DATASALE.VRTXSEVENDA != 0){
			temTaxa = '. O desconto na taxa de serviço é aplicado separadamente. Valor da taxa para essa venda R$' +  (paymentData.DATASALE.VRTXSEVENDA).toFixed(2).replace('.', ',') + '.';
		}
	  	return MESSAGE.VR_MAX_DISCOUNT + paymentData.numeroProdutos + MESSAGE.VR_MAX_DISCOUNT_P2 + temTaxa + MESSAGE.VR_MAX_DISCOUNT_P3 + ((paymentData.DATASALE.TOTAL) - (0.01 * paymentData.numeroProdutos) - paymentData.DATASALE.FIDELITYVALUE).toFixed(2).replace('.', ',') + '.';
	};

	this.getMaxTaxDiscountMessage = function (discountPopup) {
		return PaymentRepository.findOne().then(function (paymentData) {
			if(!isNaN(paymentData.DATASALE.VRTXSEVENDA)){
				paymentData.DATASALE.VRTXSEVENDA = 0;
			}
			return "Valor excedido. O valor máximo de desconto que pode ser aplicado na taxa de serviço é de R$'" + (paymentData.DATASALE.VRTXSEVENDA).toFixed(2).replace('.', ',') + '.';
		});
	};

	this.cancelDiscount = function (discountPopup) {
		OperatorRepository.findOne().then(function(operatorData) {
			PaymentRepository.findOne().then(function(payment){
				var msg = MESSAGE.REMOVE_DISCOUNT;
				if(
					(payment.descontoPromocoesIntPayment||null)||
					(payment.descontoPromocoesIntWallet||null)||
					((payment.descontoPromocoesIntOffers||null)&&operatorData.modoHabilitado=='B')
				){
					msg = MESSAGE.REMOVE_DISCOUNT_PROMOCOESINT;
				}
				PaymentService.getPaymentValue().then(function (DATASALE) {
					if (!!DATASALE.VRDESCONTO) {
						ScreenService.confirmMessage(
							msg, 'question',
							function () {
								return self.removeDesconto(discountPopup.currentRow).then(function(){
									self.attScreen(discountPopup);
								});
							}.bind(this),
							function () { }
						);
					} else {
						ScreenService.showMessage(MESSAGE.NO_DISCOUNT, 'alert');
					}
				});
			});
		});
	};

	this.removeDesconto = function(currentRow){
		// zera desconto
		currentRow.TIPODESCONTO = 'P';
		currentRow.VRDESCONTO = 0;
		currentRow.MOTIVODESCONTO = null;
		currentRow.CDOCORR = null;
		return PaymentService.handleApplyDiscount(currentRow);
	};

	this.receivePersonalCredit = function (creditDetails) {
		if (this.checkCreditDetails(creditDetails)) {
			OperatorRepository.findOne().then(function (params) {
				var accountData = {
					"CDCLIENTE": creditDetails.CDCLIENTE,
					"CDCONSUMIDOR": creditDetails.CDCONSUMIDOR,
					"CDFAMILISALD": creditDetails.CDFAMILISALD,
					"VRRECARGA": creditDetails.VRRECARGA,
					"CREDITOPESSOAL": true
				};

				var accountDetails = {
					"vlrtotal": creditDetails.VRRECARGA,
					"vlrservico": 0,
					"vlrprodutos": creditDetails.VRRECARGA,
					"vlrdesconto": 0,
					"fidelityDiscount": 0,
					"numeroProdutos": 0
				};

				PaymentService.initializePayment(accountData, accountDetails, null, null, null, null, null).then(function () {
					WindowService.openWindow('PAYMENT_TYPES_SCREEN');
				});
			});
		}
	};

	this.checkCreditDetails = function (creditDetails) {
		if (creditDetails.CDCLIENTE == null || creditDetails.CDCLIENTE.length == 0 ||
			creditDetails.CDCONSUMIDOR == null || creditDetails.CDCONSUMIDOR.length == 0 ||
			creditDetails.CDFAMILISALD == null || creditDetails.CDFAMILISALD.length == 0 ||
			creditDetails.VRRECARGA == null) {
			ScreenService.showMessage("Favor preencher todos os campos.");
			return false;
		}
		else if (creditDetails.IDPERMCARGACRED == "N") {
			ScreenService.showMessage("Esta familia não está habilitada para receber carga de crédito.");
			return false;
		}
		else if (isNaN(creditDetails.VRRECARGA)) {
			ScreenService.showMessage("Favor informar um valor de recarga válido.");
			return false;
		}
		else if (creditDetails.VRRECARGA <= 0) {
			ScreenService.showMessage("Valor da recarga tem que ser maior que 0.");
			return false;
		}
		else {
			return true;
		}
	};

	this.setPaymentTypes = function (mode, container) {
		ParamsGroupPriceChart.findAll().then(function (paymentGroups) {
			ParamsPriceChart.findAll().then(function (paymentTypes) {
				var filteredPayments = self.paymentTypeFilter(mode, paymentGroups, paymentTypes, operatorData.IDCONSUBDESFOL, operatorData.IDPERCOMVENCPDC);
				GroupPriceChart.clearAll().then(function () {
					PriceChart.clearAll().then(function () {
						GroupPriceChart.save(filteredPayments.newPaymentGroups).then(function () {
							PriceChart.save(filteredPayments.newPaymentTypes).then(function () {
								container.getWidget('categories').reload().then(function () {
									container.getWidget('pricechart').reload().then(function () {
										// Stops a bug where all the payment types get loaded in at the same time.
										if (!_.isEmpty(container.getWidget('categories').dataSource.data)) {
											var firstGroup = container.getWidget('categories').dataSource.data[0];
											var filter = [{
												name: container.getWidget('categories').valueField,
												operator: '=',
												value: firstGroup[container.getWidget('categories').valueField]
											}];
											container.getWidget('pricechart').dataSource.filter(filter).then(function (filtered) {
												container.getWidget('pricechart').dataSource.data = filtered;
											});
										}
									});
								});
							});
						});
					});
				});
            });
        });
    };

	this.paymentTypeFilter = function (mode, paymentGroups, paymentTypes, IDCONSUBDESFOL, IDPERCOMVENCPDC) {
		var arrTypes = self.handlePaymentTypes(mode, IDCONSUBDESFOL, IDPERCOMVENCPDC);

		var newPaymentTypes = _.filter(paymentTypes, function (paymentType) {
			return _.includes(arrTypes, paymentType.IDTIPORECE);
		}.bind(this));

		var arrGroups = _.uniq(_.map(newPaymentTypes, function (newPaymentType) { return newPaymentType.CDGRUPO; }));
		var newPaymentGroups = _.filter(paymentGroups, function (newPaymentGroup) {
			return _.includes(arrGroups, newPaymentGroup.CDGRUPO);
		}.bind(this));

		// prepara novo dataSource (falha do zeedhi obriga a realizar este procedimento)
		newPaymentGroups = _.map(newPaymentGroups, function (newPaymentGroup) {
			newPaymentGroup.selected = false;
			newPaymentGroup.visible = true;
			return newPaymentGroup;
		}.bind(this));
		if (!_.isEmpty(newPaymentGroups)) {
			newPaymentGroups[0].selected = true;
		}

		return {
			'newPaymentTypes': newPaymentTypes,
			'newPaymentGroups': newPaymentGroups
		};
	};

    this.handlePaymentTypes = function (mode, IDCONSUBDESFOL, IDPERCOMVENCPDC){
        // À Vista
        var cash = Array('1', '2', '3', '4', '5', '6', '7', '8', 'B', 'C', 'E', 'F', 'G', 'H');
        // Débito Consumidor
        var consumer = Array('A');
        // Crédito Pessoal
        var personal = Array('9');

        var arrTypes = Array();
        mode = !_.isEmpty(mode) ? String(mode) : '7';
        switch (mode) {
            case '1': // Débito Consumidor (so utiliza A)
                arrTypes = consumer;
                break;
            case '2': // Crédito Pessoal (so utiliza 9)
                arrTypes = personal;
                break;
            case '3': // A Vista (todos os idtiporece menos 9 e A)
                if (IDCONSUBDESFOL === 'S'){
                    arrTypes = _.concat(consumer, cash);
                }
                else {
                    arrTypes = cash;
                }
                break;
            case '4': // Débito Consumidor/Crédito Pessoal (so utiliza 9 e A)
                arrTypes = _.concat(consumer, personal);
                break;
            case '5': // Débito Consumidor/A Vista (so nao utiliza o 9)
                arrTypes = _.concat(consumer, cash);
                break;
            case '6': // Crédito Pessoal/A Vista (so nao utiliza o A)
                arrTypes = _.concat(personal, cash);
                break;
            case '7': // Todos (tudo)
                arrTypes = _.concat(personal, consumer, cash);
                break;
            default:
                arrTypes = cash;
        }
        if(IDPERCOMVENCPDC == 'S' && mustComplete) arrTypes = cash;

        return arrTypes;
    };

	this.accountAddition = function (widget) {
		self.canHandleAccountAddition().then(function (canHandleAccountAddition) {
			if (!canHandleAccountAddition.error) {
				ScreenService.confirmMessage(
					MESSAGE.ALTER_ADDITION, 'question',
					function () {
						PermissionService.checkAccess('retirarTaxaServico').then(function (CDSUPERVISOR) {
							PaymentService.handleAccountAddition(CDSUPERVISOR).then(function () {
								self.attStripeData(widget);
							});
						});
					},
					function () { }
				);
			} else {
				ScreenService.showMessage(canHandleAccountAddition.message, 'alert');
			}
		});
	};

	this.canHandleAccountAddition = function () {
		var resultFormat = {
			'error': true,
			'message': ''
		};

		return PaymentService.getPaymentValue().then(function (DATASALE) {
			if (!DATASALE.VRTXSEVENDA) {
				resultFormat.message = MESSAGE.NO_ADDITION;
			} else if (!DATASALE.FALTANTE) {
				resultFormat.message = MESSAGE.BLOCK_PAYMENT;
			} else {
				resultFormat.error = false;
			}

			return resultFormat;
		});
	};

	this.handleEnterButton = function (args) {
		var keyCode = args.e.keyCode;
		if (keyCode === 9 || keyCode === 13) {
			UtilitiesService.handleCloseKeyboard();
			var widget = args.owner.field.widget;

			if (widget.name === 'discountPopup')
				this.setDiscount(widget);
			else if (widget.name === 'paymentPopup')
				this.setPayment(widget);
			else if (widget.name === 'consumerCPFPopup')
				this.setConsumerInfo(widget);
			else if (widget.name === 'setEmailConsumerPopUp') {
				self.enviaCupomEmail(widget, true);
			} else if (widget.name === 'popupConsumidorBalcao'){
				this.cardSwipeHandler(widget);
			}
		}
	};

    this.cardSwipeHandler = function(widget){
        OperatorRepository.findOne().then(function(operatorData){
            if (!_.isEmpty(widget.currentRow.consumerSearch) &&
                (!_.isEmpty(operatorData.NRPOSINICONS) && parseInt(operatorData.NRPOSINICONS) > 0) &&
                (!_.isEmpty(operatorData.NRPOSFINCONS) && parseInt(operatorData.NRPOSFINCONS) > 0)
            ){
                widget.currentRow.consumerSearch = widget.currentRow.consumerSearch.substring(operatorData.NRPOSINICONS-1, operatorData.NRPOSFINCONS);
            }
        });
    };

	this.handlePrintNote = function (payAccountResult) {
		return new Promise(function (resolve) {
				if(operatorData.IDSOLIMPCUPFIS == 'S'){
					ScreenService.confirmMessage(MESSAGE.CONFIRM_PRINT, 'question', function () {
						return self.isCardSale(payAccountResult).then(function(){
							return resolve();
						});
					}, function () {
						payAccountResult.data.dadosImpressao.TEXTOCUPOM1VIA = null;
						return self.isCardSale(payAccountResult).then(function(){
							return resolve();
						});
					});
				} else {
					return self.isCardSale(payAccountResult).then(function(){
						return resolve();
					});
				}
		});
	};

	this.contadorloopTimeoutImpressao=0;
	this.loopTimeoutImpressao = function(stMensagem){
		setTimeout(function(){
			if(self.contadorloopTimeoutImpressao>5 || self.contadorloopTimeoutImpressao==0){
				if(self.contadorloopTimeoutImpressao>5){
					self.contadorloopTimeoutImpressao=0;
				}
				ScreenService.changeLoadingMessage(stMensagem+self.time);
				self.time = self.time-1;
			}
			self.contadorloopTimeoutImpressao=self.contadorloopTimeoutImpressao+1;
			if(self.forcaParadaTimeOut){
				self.time = -1;
				self.contadorloopTimeoutImpressao = 0;
				return;
			}
			if(self.time <= 0){
				self.contadorloopTimeoutImpressao = 0;
				self.paraTimeoutImpressao();
			} else {
				self.loopTimeoutImpressao(stMensagem);
			}
		},200);
	};
	
	this.iniciaTimeoutImpressao = function(stMensagem){
		stMensagem = stMensagem||"Aguarde a impressão do cupom fiscal...  ";
		window.log("iniciaTimeoutImpressao "+stMensagem);
		self.paraTimeoutImpressao(false);
		self.time = 39;
		self.forcaParadaTimeOut = false;
		ScreenService.hideLoader();
		ScreenService.showLoader();
		self.loopTimeoutImpressao(stMensagem);
	};

	this.paraTimeoutImpressao = function(executar){
		executar = (executar===undefined)?true:executar;
		if(executar && !!window.ApplicationContext.PrinterService.impressionResolved){
			//if para chamar o resolve da impressão somente após começar a imprimir
			window.ApplicationContext.PrinterService.endPrint();
			window.ApplicationContext.PrinterService.impressionResolved({error:true,message:'Timeout de impressão atingido.'});
			window.ApplicationContext.PrinterService.impressionResolved = null;
		}
		self.forcaParadaTimeOut = true;
		self.time = -1;
		ScreenService.changeLoadingMessage("Aguarde...");
		ScreenService.hideLoader();
		ScreenService.hideLoader();
	};

	this.isCardSale = function (payAccountResult) {
		self.iniciaTimeoutImpressao("Aguarde a impressão do cupom fiscal...  ");
		if (!_.isEmpty(payAccountResult.data.dadosImpressao.TEFVOUCHER)) {
			return self.handleReceiptCustomer(payAccountResult);
		} else {
			return PaymentService.handlePrintReceipt(payAccountResult.data.dadosImpressao, false).then(function(){
				return self.payAccountFinish(payAccountResult);
			});
		}
	};

	this.handleReceiptCustomer = function (payAccountResult) {
		return new Promise(function (resolve) {
				ScreenService.confirmMessage(MESSAGE.PRINT_VIA_CLI, 'question', function () {
					PaymentService.handlePrintReceipt(payAccountResult.data.dadosImpressao, false).then(function(){
						self.payAccountFinish(payAccountResult).then(function(){
							return resolve();
						});
					});
				}, function () {
					payAccountResult.data.dadosImpressao.TEFVOUCHER = _.map(payAccountResult.data.dadosImpressao.TEFVOUCHER, function (n) {
						n.STLPRIVIA = null;
						return n;
					});
					PaymentService.handlePrintReceipt(payAccountResult.data.dadosImpressao, false).then(function(){
						self.payAccountFinish(payAccountResult).then(function(){
							return resolve();
						});
					});
				}
			);
		});
	};

	this.imprimePedidosMaquininha = function(payAccountResult, stErro){
		stErro=stErro||"";
		window.log("Chamada imprime pedidos na maquininha");
		var promisePedidoProducao = Array();
		if (!_.isEmpty(_.get(payAccountResult, 'data.paramsImpressora'))) {
			if(!Array.isArray(payAccountResult.data.paramsImpressora)){
				payAccountResult.data.paramsImpressora = Array(payAccountResult.data.paramsImpressora);
			}
			if(payAccountResult.data.paramsImpressora[0].IDUTILIMPFRONT == true){
				promisePedidoProducao.push(
					PerifericosService.print(payAccountResult.data.paramsImpressora, payAccountResult.data.impressaoPedidoSmart)
				);
			}
		}
		if (!_.isEmpty(_.get(payAccountResult, 'data.impressaoPedidoSmart'))) {
			if(operatorData.IDIMPPEDPRCIGE == 'S'){
				self.iniciaTimeoutImpressao("Aguarde a impressão dos produtos...  ");
				promisePedidoProducao.push(
					self.printOrderIntegration(payAccountResult.data.impressaoPedidoSmart, stErro)
				);
			}
		}
		return Promise.all(promisePedidoProducao).then(function(repetir){
			self.paraTimeoutImpressao(false);
			repetir=repetir||"";
			if(repetir){
				if(repetir.indexOf(false)>=0){
					//retorna sem fazer nada
					return;
				} else if(repetir.indexOf("generic")>=0 || repetir.indexOf("outros")>=0){
					ScreenService.showLoader();
					return new Promise(function(resolve){ setTimeout(function(){ resolve(); },2000); }).then(function(){
						if(repetir.indexOf("generic")>=0){
							return self.imprimePedidosMaquininha(payAccountResult,"generic");
						} else {
							return self.imprimePedidosMaquininha(payAccountResult,"outros");
						}
					});
				} else {
					/*
					ScreenService.showLoader();
					ScreenService.changeLoadingMessage("Aguarde, iniciando teste automático");
					return new Promise(function(resolve){
						setTimeout(function(){
							ScreenService.changeLoadingMessage("Aguarde, iniciando teste automático");
						},1000);
						setTimeout(function(){ resolve(); },10000);
					}).then(function(){
						return self.imprimePedidosMaquininha(payAccountResult);
					});
					*/
				}
			}
		});
	};

	this.printOrderIntegration = function (impressaoPedidoSmart, boSegundaTentativa){
		boSegundaTentativa=boSegundaTentativa||"";
		return new Promise(function (resolve) {
			if(impressaoPedidoSmart.length>0){
				if(impressaoPedidoSmart.length>1){
					window.log("Tratamento para duplicidade, quantidade inicial "+impressaoPedidoSmart.length);
					impressaoPedidoSmart = self.validaDuplicidade(impressaoPedidoSmart)||impressaoPedidoSmart;
					window.log("Tratamento para duplicidade, quantidade final "+impressaoPedidoSmart.length);
				}
				impressaoPedidoSmart.forEach(function(pedidos){
					if (WindowService.validaModeloIMP(pedidos.impressora.IDMODEIMPRES)) {
						var contador = 1;
						if(boSegundaTentativa != "" && (['49']).indexOf(operatorData.IDMODEIMPRES)>=0 ){
							//PrinterService.printerLimpaBufferAguardaCallback();
						}
						pedidos.comandos.forEach(function(comandos){
							comandos = comandos||{};
							if (comandos.name=="text") {
								comandos.parameters = comandos.parameters||{};
								if(comandos.parameters.text){
									PrinterService.printerCommand(PrinterService.TEXT_COMMAND, comandos.parameters.text, comandos.parameters);
								}
							} else if (comandos.name=="imagemBase64") {
								if((['49']).indexOf(operatorData.IDMODEIMPRES)>=0){
									if(boSegundaTentativa=="generic" && contador>1 && (contador%2)==0 ){
										PrinterService.printerImprimirAguardarCallback();
										PrinterService.printerLimpaBufferAguardaCallback();
									}
								}
								contador=contador+1;
								PrinterService.printerImagemBase64(comandos.parameters.datauri);
							}
						});
					}
				});

				var arrPromiseImpressao = Array();
				impressaoPedidoSmart.forEach(function(pedidos){
					if (WindowService.validaModeloIMP(pedidos.impressora.IDMODEIMPRES)) {
						if(!_.isEmpty(PrinterService.printerCommands)) {
							//PrinterService.printerSpaceCommand(1);
							arrPromiseImpressao.push(
								PrinterService.printerInit('40').then(function (result) {
									if (result.error) {
										ScreenService.alertNotification(result.message);
									}
									return result;
								})
							);
						}
					}
				});
				Promise.all(arrPromiseImpressao).then(function(resposta){
					var erro = null;
					for (var index = 0; index < resposta.length; index++) {
						if(resposta[index].error || resposta[index].erro){
							erro = (resposta[index].message||'')+" Falha na impressão dos produtos, deseja imprimir novamente?";
							break;
						}
					}
					if(erro){
						self.paraTimeoutImpressao(false);
						ScreenService.confirmMessage(erro,
							'question',
							function(){
								window.ApplicationContext.GeneralFunctions.verificaAcessoSupervisor('', 'reimpressaoFiscal').then(function(){
									window.log("Tenta imprimir novamente.");
									self.iniciaTimeoutImpressao("Aguarde a nova tentativa de imprimir os produtos...  ");
									var boErrogeneric = "outros";
									if(typeof(erro) === 'string') {
										if(erro.toLowerCase().indexOf("generic")>=0){
											boErrogeneric = "generic";
										}
									}
									return resolve(boErrogeneric);
								},function(){
									window.log("Não imprime novamente.");
									return resolve();
								});
							},
							function(){
								window.log("Não imprime novamente.");
								return resolve();
							});
					} else {
						resolve();
					}
				});
			} else {
				resolve();
			}
		});
	};

	this.validaDuplicidade = function(arrImpressao){
		for (var index = 0; index < arrImpressao.length; index++) {
			var posAtual = arrImpressao[index];
			for (var index2 = 0; index2 < arrImpressao.length; index2++) {
				if(index2==index){continue;}
				var proximaPosicao = arrImpressao[index2]||{};
				proximaPosicao.comandos = proximaPosicao.comandos||[];
				posAtual.comandos = posAtual.comandos||[];
				if(proximaPosicao.comandos.length == posAtual.comandos.length){
					var posicaoDuplicada = true;
					for (var i = 0; i < proximaPosicao.comandos.length; i++) {
						if(proximaPosicao.comandos[i].name == posAtual.comandos[i].name){
							if(
								(proximaPosicao.comandos[i].parameters.text||'') == (posAtual.comandos[i].parameters.text||'')&&
								(proximaPosicao.comandos[i].parameters.datauri||'') == (posAtual.comandos[i].parameters.datauri||'')
							){
								//
							} else {
								posicaoDuplicada=false;
							}
						} else {
							posicaoDuplicada=false;
						}
					}
					if(posicaoDuplicada){
						arrImpressao.splice(1, index2);
					}
				}
			}
		}
		return arrImpressao;
	};

	this.verificaEnvioCupomEmail = function (adiantamento) {
		var cupomPorEmail = operatorData.IDENVCUPOMEMAIL;
		if(!adiantamento && cupomPorEmail == 'S'){
			self.openPopupEnviaCupomEmail();
		} else {
			self.payAccount(adiantamento);
		}
	};

	this.openPopupEnviaCupomEmail = function () {
		PaymentRepository.findOne().then(function(consumerData){
			var widgetPayment = templateManager.container.getWidget('paymentMenu');
			self.criaWidget(widgetPayment.container,'setEmailConsumerPopUp');
			var setEmailConsumerPopUp = widgetPayment.container.getWidget('setEmailConsumerPopUp');
			consumerEmail = setEmailConsumerPopUp.getField('consumerEmail');
			if(!_.isEmpty(consumerData.DSEMAILCONS)){
				consumerEmail.setValue(consumerData.DSEMAILCONS);
			} else {
				consumerEmail.setValue("");
			}
			ScreenService.openPopup(setEmailConsumerPopUp);
			ScreenService.hideLoader();
		});
	};

	this.enviaCupomEmail = function (widget, informaEmail) {
		if(informaEmail){
			consumerEmail = widget.getField('consumerEmail');
			if (self.validateEmailConsumer(consumerEmail)) {
				PaymentRepository.findOne().then(function (paymentData) {
					paymentData.DSEMAILCONS = widget.getField('consumerEmail').value();
					paymentData.INFORMAEMAIL = informaEmail;
					PaymentRepository.save(paymentData);
					self.payAccount();
					ScreenService.closePopup();
				});
			}
		} else {
			self.payAccount();
		}
	};

	this.validateEmailConsumer = function(field) {
		if (!field.widget.isValid()){
            ScreenService.showMessage("Favor preencher o e-mail.");
        }
		if (!UtilitiesService.checkEmail(field.value())){
			ScreenService.showMessage('E-mail inválido.<br><br>Verifique e tente novamente.');
            return false;
		}
        return true;
	};

	this.solicitaTel = function(widget) {
		if ((operatorData.IDSOLICTELGER == 'S' || operatorData.IDSOLICITATEL == 'S') && operatorData.modoHabilitado != "B") {
			self.criaWidget(widget,'solicitaTelPopUp');
			ScreenService.openPopup(widget.getWidget('solicitaTelPopUp'));
		}
	};

    this.saveTelCons = function(solicitaTelPopUpInfo) {
		PaymentRepository.findOne().then(function (paymentData){
			var telField = solicitaTelPopUpInfo.getField('consumerPhone');
			if (telField.widget.currentRow.consumerPhone) {
				if (self.validatePhoneConsumer(telField)) {
					telConsumidor = (telField .value()).replace(/\D/g, '');
					paymentData.NRTELCRM = telConsumidor;
					PaymentRepository.save(paymentData);
					solicitaTelPopUpInfo.getField('consumerPhone').clearValue();
					ScreenService.closePopup();
				}
				solicitaTelPopUpInfo.getField('consumerPhone').clearValue();
			} else {
				telConsumidor = null;
				solicitaTelPopUpInfo.getField('consumerPhone').clearValue();
				ScreenService.closePopup();
			}
		});
    };

    this.validatePhoneConsumer = function(field) {
		if (!UtilitiesService.checkPhone(field.value())){
			ScreenService.showMessage('Telefone inválido.<br><br>Verifique e tente novamente.');
            return false;
		}
        return true;
	};

	this.prepareFidelityCRM = function(widget) {
		if(operatorData.IDCRMBONUS == 'S' && operatorData.IDSOLICITATEL != 'S'){
			self.criaWidget(widget,'crmBonusPopUp');
			ScreenService.openPopup(widget.getWidget('crmBonusPopUp'));
		}
	};

	this.getCrmBunus = function(widgetCRM, consultaCRM) {
		PaymentRepository.findOne().then(function (paymentData) {
			if(consultaCRM){
				telefoneConsumidor = widgetCRM.getField('consumerPhone');
				if (!_.isEmpty(telefoneConsumidor) && self.validatePhoneConsumer(telefoneConsumidor)){
					telefoneConsumidor = (telefoneConsumidor.value()).replace(/\D/g, '');
					PaymentService.callCrmBunus(telefoneConsumidor, paymentData.DATASALE.TOTALVENDA).then(function (result){
						paymentData.DATASALE.fidelityDetails = result;
						paymentData.DATASALE.PHONECRM = telefoneConsumidor;
						PaymentRepository.save(paymentData);
						saldo = result[0].data.saldo_bonus;
						self.confirmaCrmBonus(telefoneConsumidor, saldo, widgetCRM);
						widgetCRM.getField('consumerPhone').clearValue();
        				ScreenService.closePopup();
					});
					widgetCRM.getField('consumerPhone').clearValue();
        			ScreenService.closePopup();
        		}
        		//widgetCRM.getField('consumerPhone').clearValue();
        		//ScreenService.closePopup();
			} else {
        		paymentData.DATASALE.PHONECRM = null;
				PaymentRepository.save(paymentData);
				widgetCRM.getField('consumerPhone').clearValue();
        		ScreenService.closePopup();
        	}
		});
	};

	this.confirmaCrmBonus = function(telefoneConsumidor, saldoBonus, widget) {
		PaymentRepository.findOne().then(function (paymentData) {
			if(saldoBonus > 0){
				ScreenService.confirmMessage(
					"Consumidor CRM&BONUS encontrado. <br>Saldo disponível: R$" + saldoBonus.toFixed(2).replace('.', ',') + ". <br><br>Deseja utilizá-lo como desconto na compra?",
					'question',
					function () {
						self.aplicaDescCrmBonus(telefoneConsumidor, saldo, widget);
					},
					function () {
						paymentData.DATASALE.PHONECRM = telefoneConsumidor;
						paymentData.desconto.motivoDesconto = "CRM";
                		PaymentRepository.save(paymentData);
					}
				);
			} else if(saldoBonus <= 0){
				ScreenService.showMessage("Consumidor CRM&BONUS encontrado, porém não há saldo disponível para aplicação de desconto.<br><br> Ao finalizar a venda novo saldo será gerado.");
				self.aplicaDescCrmBonus(telefoneConsumidor, saldo, widget);
			}
		});
	};

	this.aplicaDescCrmBonus = function(telefoneConsumidor, saldoBonus, widget) {
		PaymentRepository.findOne().then(function (paymentData) {
			var totalProdutos = paymentData.DATASALE.TOTALVENDA;
            var productCodes = paymentData.ITEMVENDA.map(function (product){
                return product.CDPRODUTO;
            });
            var totalCost = paymentData.DATASALE.TOTALVENDA;
            totalCost = Math.round(totalCost * 100) / 100;
            DESCONTO = saldoBonus;
            if (DESCONTO > totalCost) DESCONTO = totalCost;
            var minCost = 0.01 * paymentData.numeroProdutos;
            var maxDiscount = Math.round((totalCost - minCost) * 100) / 100;
            // Define os valores do fidelidade.
            paymentData.DATASALE.VRDESCCRM  = DESCONTO;
            paymentData.DATASALE.FIDELITYVALUE = DESCONTO; // Valor de desconto REAL que está sendo descontado na venda.
            // Se o desconto for maior or igual que o valor máximo de desconto, não podemos deixar a venda ficar zerada.
            if (DESCONTO >= maxDiscount){
                // Valor restante da venda fica limitada ao valor mínimo que pode ser cobrado.
                paymentData.DATASALE.TOTALVENDA = minCost;
                paymentData.DATASALE.FALTANTE = minCost;
                paymentData.DATASALE.VRDESCCRM  = maxDiscount;
                paymentData.DATASALE.FIDELITYVALUE = maxDiscount;
            } else {
                // Ajusta os valores da venda.
                paymentData.DATASALE.TOTALVENDA = paymentData.DATASALE.TOTALVENDA - DESCONTO;
                paymentData.DATASALE.TOTALVENDA = Math.round(paymentData.DATASALE.TOTALVENDA * 100) / 100;
                paymentData.DATASALE.FALTANTE = paymentData.DATASALE.FALTANTE - DESCONTO;
                paymentData.DATASALE.FALTANTE = Math.round(paymentData.DATASALE.FALTANTE * 100) / 100;
            }
            paymentData.DATASALE.FIDELITYDISCOUNT = DESCONTO;
            paymentData.desconto.motivoDesconto = "CRM";
            paymentData.DATASALE.PHONECRM = telefoneConsumidor;
            PaymentRepository.save(paymentData).then(function (){
                AccountController.getAccountData(function (accountData){
                    if(accountData.length){
                        AccountService.setDiscountFidelity(accountData[0].NRVENDAREST, accountData[0].NRCOMANDA, paymentData.DATASALE.CPF4ALL, 0, 0, 0, paymentData.DATASALE.CPFUDS, telefoneConsumidor, saldoBonus).then(function (){
                        	ApplicationContext.PaymentController.attScreen(widget);
                        });
                    } else {
                        ApplicationContext.PaymentController.attScreen(widget);
                    }
                });
            });
		});
	};

	this.validatePhoneConsumer = function(field) {
		if (!field.widget.isValid()){
            ScreenService.showMessage("Favor preencher o número de telefone.");
            return false;
        }
		if (!UtilitiesService.checkPhone(field.value())){
			ScreenService.showMessage('Telefone inválido.<br><br>Verifique e tente novamente.');
            return false;
		}
        return true;
	};
    this.openPopupPromocoesInt = function(container){
		var popupBuscarPromocoesInt = container.getWidget('popupBuscarPromocoesInt');
		PaymentRepository.findOne().then(function(payment){
		PaymentService.handleOpenDiscount().then(function(handleOpenDiscountResult){
		AccountGetAccountDetails.findOne().then(function(accountDetails) {
			if(operatorData.modoHabilitado == 'B'){
				self.openPopupPromocoesIntVendaBalcao(popupBuscarPromocoesInt,payment,handleOpenDiscountResult);
			} else if(operatorData.modoHabilitado == 'M'){
				self.openPopupPromocoesIntVendaMesa(popupBuscarPromocoesInt,payment,handleOpenDiscountResult,accountDetails);
			}
		});
		});
		});
	};
	this.openPopupPromocoesIntVendaMesa = function(popupBuscarPromocoesInt,payment,handleOpenDiscountResult,accountDetails) {
		popupBuscarPromocoesInt.currentRow.NRVENDAREST = accountDetails.NRVENDAREST;
		popupBuscarPromocoesInt.currentRow.NRCOMANDA = accountDetails.NRCOMANDA;
		popupBuscarPromocoesInt.currentRow.NRCPFINTEPROMO = accountDetails.NRCPFINTEPROMO||null;
		popupBuscarPromocoesInt.currentRow.IDPEDINTEPROMO = accountDetails.IDPEDINTEPROMO||null;

		var buscaPromocoesIntPayment = popupBuscarPromocoesInt.getField('buscaPromocoesIntPayment');
		var buscaPromocoesIntWallet  = popupBuscarPromocoesInt.getField('buscaPromocoesIntWallet');
		var buscaPromocoesIntOffers  = popupBuscarPromocoesInt.getField('buscaPromocoesIntOffers');

		if (!handleOpenDiscountResult.error){
			buscaPromocoesIntPayment.dataSourceFilter[0].value = operatorData.chave;
			buscaPromocoesIntWallet.dataSourceFilter [0].value = operatorData.chave;
			buscaPromocoesIntPayment.dataSourceFilter[1].value = accountDetails.NRVENDAREST;
			buscaPromocoesIntWallet.dataSourceFilter [1].value = accountDetails.NRVENDAREST;
			buscaPromocoesIntPayment.dataSourceFilter[2].value = accountDetails.NRCOMANDA;
			buscaPromocoesIntWallet.dataSourceFilter [2].value = accountDetails.NRCOMANDA;
			buscaPromocoesIntWallet.reload();
			buscaPromocoesIntPayment.reload();
		}

		buscaPromocoesIntPayment.readOnly = !(!handleOpenDiscountResult.error);
		buscaPromocoesIntWallet.readOnly  = !(!handleOpenDiscountResult.error);

		if(!(payment.descontoPromocoesIntPayment||null)){
			buscaPromocoesIntPayment.value(null);
			buscaPromocoesIntPayment.clearValue();
		} else {
			buscaPromocoesIntPayment.value(
				payment.descontoPromocoesIntPayment[0].IDPROMOCOM+" - "+
				payment.descontoPromocoesIntPayment[0].NMPROMOCOM+" - "+
				payment.descontoPromocoesIntPayment[0].dsVRPROMO
			);
		}
		if(!(payment.descontoPromocoesIntWallet||null)){
			buscaPromocoesIntWallet.value(null);
			buscaPromocoesIntWallet.clearValue();
		} else {
			if(!payment.descontoPromocoesIntWallet[0].IDPROMOCOM && payment.descontoPromocoesIntWallet[0].NMPROMOCOM =="Carteira"){
				buscaPromocoesIntWallet.value(
					payment.descontoPromocoesIntWallet[0].NMPROMOCOM+" - "+
					payment.descontoPromocoesIntWallet[0].dsVRPROMO
				);
			}
		}
		buscaPromocoesIntOffers.label = 'Promoção Offer selecionada';
		buscaPromocoesIntOffers.readOnly = true;
		buscaPromocoesIntOffers.value(accountDetails.DSPROMOCOM||null);
		popupBuscarPromocoesInt.getAction('btnConfirmar').isVisible = false;
		popupBuscarPromocoesInt.getAction('btnConfirmar').label = 'Confirmar';

		ScreenService.openPopup(popupBuscarPromocoesInt);
	};

	this.openPopupPromocoesIntVendaBalcao = function(popupBuscarPromocoesInt,payment,handleOpenDiscountResult) {

		popupBuscarPromocoesInt.currentRow.NRCPFINTEPROMO = payment.NRCPFINTEPROMO||null;
		popupBuscarPromocoesInt.currentRow.IDPEDINTEPROMO = payment.IDPEDINTEPROMO||null;

		var buscaPromocoesIntPayment = popupBuscarPromocoesInt.getField('buscaPromocoesIntPayment');
		var buscaPromocoesIntWallet  = popupBuscarPromocoesInt.getField('buscaPromocoesIntWallet');
		var buscaPromocoesIntOffers  = popupBuscarPromocoesInt.getField('buscaPromocoesIntOffers');

		buscaPromocoesIntPayment.readOnly = !(!handleOpenDiscountResult.error);
		buscaPromocoesIntWallet.readOnly  = !(!handleOpenDiscountResult.error);
		buscaPromocoesIntOffers.readOnly  = !(!handleOpenDiscountResult.error);

		if(!(payment.descontoPromocoesIntPayment||null)){
			buscaPromocoesIntPayment.value(null);
			buscaPromocoesIntPayment.clearValue();
		} else {
			buscaPromocoesIntPayment.value(
				payment.descontoPromocoesIntPayment[0].IDPROMOCOM+" - "+
				payment.descontoPromocoesIntPayment[0].NMPROMOCOM+" - "+
				payment.descontoPromocoesIntPayment[0].dsVRPROMO
			);
		}
		if(!(payment.descontoPromocoesIntWallet||null)){
			buscaPromocoesIntWallet.value(null);
			buscaPromocoesIntWallet.clearValue();
		} else {
			if(!payment.descontoPromocoesIntWallet[0].IDPROMOCOM && payment.descontoPromocoesIntWallet[0].NMPROMOCOM =="Carteira"){
				buscaPromocoesIntWallet.value(
					payment.descontoPromocoesIntWallet[0].NMPROMOCOM+" - "+
					payment.descontoPromocoesIntWallet[0].dsVRPROMO
				);
			}
		}
		if(!(payment.descontoPromocoesIntOffers||null)){
			buscaPromocoesIntOffers.value(null);
			buscaPromocoesIntOffers.clearValue();
		} else {
			buscaPromocoesIntOffers.value(
				payment.descontoPromocoesIntOffers[0].IDPROMOCOM+" - "+
				payment.descontoPromocoesIntOffers[0].NMPROMOCOM+" - "+
				payment.descontoPromocoesIntOffers[0].dsVRPROMO
			);
		}
		buscaPromocoesIntOffers.label = 'Promoções Offers disponíves';

		popupBuscarPromocoesInt.getAction('btnConfirmar').isVisible = payment.IDPEDINTEPROMO==null;
		popupBuscarPromocoesInt.getAction('btnConfirmar').label = payment.IDPEDINTEPROMO==null?'Buscar':'Confirmar';
		popupBuscarPromocoesInt.getField('NRCPFINTEPROMO').readOnly = payment.IDPEDINTEPROMO!=null;

		buscaPromocoesIntPayment.isVisible = payment.IDPEDINTEPROMO!=null;
		buscaPromocoesIntWallet.isVisible  = payment.IDPEDINTEPROMO!=null;
		buscaPromocoesIntOffers.isVisible  = payment.IDPEDINTEPROMO!=null;

		ScreenService.openPopup(popupBuscarPromocoesInt);
	};

    this.selectBuscaPromocoesInt = function(widget,field){
		PaymentRepository.findOne().then(function (payment) {
			if(operatorData.modoHabilitado == 'M'){
				if(widget.currentRow.NRSEQPROMOCOM){
					field.value(
						widget.currentRow.NRSEQPROMOCOM+" - "+
						(widget.currentRow.IDPROMOCOM?widget.currentRow.IDPROMOCOM+" - ":'')+
						widget.currentRow.NMPROMOCOM+" - "+
						widget.currentRow.dsVRPROMO
					);
				}
			} else if(operatorData.modoHabilitado == 'B'){
				if(widget.currentRow.IDPROMOCOM){
					field.value(
						widget.currentRow.IDPROMOCOM+" - "+
						widget.currentRow.NMPROMOCOM+" - "+
						widget.currentRow.dsVRPROMO
					);
				} else if(!widget.currentRow.IDPROMOCOM && widget.currentRow.NMPROMOCOM =="Carteira"){
					field.value(
						widget.currentRow.NMPROMOCOM+" - "+
						widget.currentRow.dsVRPROMO
					);
				}
			}
			widget.getAction('btnConfirmar').isVisible = false;

			validaMudanca = function(field,arrPromoInt){
				var valorAtual = field.value()||"";
				var valorAnterior = "";
				if(!!(arrPromoInt||null)){
					arrPromoInt = arrPromoInt[0];
					if(operatorData.modoHabilitado == 'M'){
						if(arrPromoInt.NRSEQPROMOCOM){
							valorAnterior =  arrPromoInt.NRSEQPROMOCOM+" - "+
											 (arrPromoInt.IDPROMOCOM?arrPromoInt.IDPROMOCOM+" - ":'')+
											 arrPromoInt.NMPROMOCOM+" - "+
											 arrPromoInt.dsVRPROMO;
						}
					} else if(operatorData.modoHabilitado == 'B'){
						if(arrPromoInt.IDPROMOCOM){
							valorAnterior = arrPromoInt.IDPROMOCOM+" - "+
											arrPromoInt.NMPROMOCOM+" - "+
											arrPromoInt.dsVRPROMO;
						} else if(!arrPromoInt.IDPROMOCOM && arrPromoInt.NMPROMOCOM =="Carteira"){
							valorAnterior = arrPromoInt.NMPROMOCOM+" - "+
											arrPromoInt.dsVRPROMO;
						}
					}
				}
				return (valorAtual!=valorAnterior);
			};
			widget.getAction('btnConfirmar').isVisible = (
				validaMudanca(widget.getField('buscaPromocoesIntPayment'),payment.descontoPromocoesIntPayment)||
				validaMudanca(widget.getField('buscaPromocoesIntOffers'),payment.descontoPromocoesIntOffers)||
				validaMudanca(widget.getField('buscaPromocoesIntWallet'),payment.descontoPromocoesIntWallet)
			);
		});
    };

	this.getPromocoesInt = function(widget){
		// Valida se o CPF foi digitado.
		var stCPF = (widget.currentRow.NRCPFINTEPROMO);
		if (_.isEmpty(stCPF)){ /*o cpf é opcional*/
		} else {
			// Valida o CPF.
			stCPF = stCPF.replace(/[^0-9 ]/g, "");
			if (!UtilitiesService.isValidCPForCNPJ(stCPF)){
				ScreenService.showMessage('CPF inválido.', 'alert');
				return;
			}
		}
		PaymentRepository.findOne().then(function(payment){
			var arrProdutos = null;
			if(payment.ITEMVENDA){
				if(payment.ITEMVENDA.length>0){
					arrProdutos = Array();
					for (var item of payment.ITEMVENDA) {
						arrProdutos.push({
							'CDPRODUTO':item.CDPRODUTO,
							'QTPRODCOMVEN':item.QTPRODCOMVEN,
							'VRPRECCOMVEN':item.PRITEM,
							'NRPRODCOMVEN':item.ID,
							'DTHRINCOMVEN':null
						});
					}
				}
			}
			AccountService.enviaCarrinhoPromocoesInt(operatorData.chave,null,null,arrProdutos).then(function(retSendCart){
				retSendCart = retSendCart[0]||false;
				retSendCart.success = retSendCart.success||false;
				retSendCart.message = retSendCart.message||'Não foi possivel enviar o carrinho para o servidor.';
				retSendCart.orderId = null;
				if(retSendCart.data){
					if(!retSendCart.data.orderId && retSendCart.data.id){
						retSendCart.data.orderId = retSendCart.data.id;
					}
					if(retSendCart.data.orderId){
						retSendCart.orderId=retSendCart.data.orderId;
					}
				}
				if(!retSendCart.orderId && retSendCart.success){
					retSendCart.success = false;
					retSendCart.message = 'Erro Order Id não foi retornado na consulta.';
				}
				if(!retSendCart.success){
					ScreenService.hideLoader();
					ScreenService.showMessage(retSendCart.message.substr(0,300));
					return;
				}
				AccountService.consultaPromocoesInt(retSendCart.orderId).then(function(retConsultCart){
					retConsultCart = retConsultCart[0]||false;
					if(retConsultCart.success){
						retConsultCart = AccountController.formataObjPromocoesInt(retConsultCart);
						widget.retConsultCart = retConsultCart;
						if(Object.keys(retConsultCart.offers).length<1){
							ScreenService.showMessage('Produtos sem promoções cadastradas.');
						} else {
							var stNRCPFINTEPROMO  = widget.getField('NRCPFINTEPROMO').value();
							var arrdata = Array();
							retConsultCart.offers.data.forEach(function(data,i){
								if( data.applied.data.id!='NULL' && data.applied.data.id ){
									var arrtemp = {};
									arrtemp.IDPEDINTEPROMO=retConsultCart.orderId;
									arrtemp.NRCPFINTEPROMO=stNRCPFINTEPROMO;
									arrtemp.NRSEQPROMOCOM=null;
									arrtemp.IDPROMOCOM=data.applied.data.id;
									arrtemp.NMPROMOCOM=data.applied.data.name;
									arrtemp.DSPROMOCOM=data.applied.data.description;
									arrtemp.IDTPPROMOCOM='O';
									arrtemp.IDTPDESCPROMO='V';
									arrtemp.VRDESCPROMO=null;
									var valor = String(data.total);
									valor=parseFloat(valor.replace(',', '.'));

									arrtemp.VRVENDAPROMO=valor;

									valor=UtilitiesService.formatFloat(valor);
									arrtemp.dsVRPROMO="R$ "+valor;
									arrdata.push(arrtemp);
								}
							});
							var buscaPromocoesIntOffers = widget.getField('buscaPromocoesIntOffers');
							buscaPromocoesIntOffers.dataSourceFilter[4].value = Object.assign({}, arrdata);
							buscaPromocoesIntOffers.reload();

							arrdata = Array();
							if(retConsultCart.wallet){
								if(retConsultCart.wallet.value && retConsultCart.wallet.type){
									if(retConsultCart.wallet.type=='1'||retConsultCart.wallet.type=='2'){
										var arrtemp = {};
										arrtemp.IDPEDINTEPROMO=retConsultCart.orderId;
										arrtemp.NRCPFINTEPROMO = stNRCPFINTEPROMO;
										arrtemp.NRSEQPROMOCOM=null;
										arrtemp.IDPROMOCOM=null;
										arrtemp.NMPROMOCOM='Carteira';
										arrtemp.DSPROMOCOM=null;
										arrtemp.IDTPPROMOCOM='W';
										arrtemp.VRVENDAPROMO=null;
										var valor = String(retConsultCart.wallet.value);
										valor=parseFloat(valor.replace(',', '.'));

										arrtemp.VRDESCPROMO=valor;

										valor=UtilitiesService.formatFloat(valor);
										if(retConsultCart.wallet.type=='1'){
											valor="R$ "+valor;
											arrtemp.IDTPDESCPROMO='V';
										} else if(retConsultCart.wallet.type=='2'){
											valor=valor+"%";
											arrtemp.IDTPDESCPROMO='P';
										}
										arrtemp.dsVRPROMO=valor;
										arrdata.push(arrtemp);
									}
								}
							}
							var buscaPromocoesIntWallet = widget.getField('buscaPromocoesIntWallet');
							buscaPromocoesIntWallet.dataSourceFilter[4].value = Object.assign({}, arrdata);
							buscaPromocoesIntWallet.reload();

							arrdata = Array();
							retConsultCart.paymentsOffer.data.forEach(function(data,i){
								if( data.discountType == '1'||data.discountType == '2'){
									var arrtemp = {};
									arrtemp.IDPEDINTEPROMO=retConsultCart.orderId;
									arrtemp.NRCPFINTEPROMO = stNRCPFINTEPROMO;
									arrtemp.NRSEQPROMOCOM=null;
									arrtemp.IDPROMOCOM=data.paymentCode;
									arrtemp.NMPROMOCOM=data.name;
									arrtemp.DSPROMOCOM=null;
									arrtemp.IDTPPROMOCOM='P';
									if( data.discountType == '1'){
										arrtemp.IDTPDESCPROMO='V';
									} else if( data.discountType == '2'){
										arrtemp.IDTPDESCPROMO='P';
									}
									arrtemp.VRVENDAPROMO=null;
									var valor = String(data.discountValue);
									valor=parseFloat(valor.replace(',', '.'));

									arrtemp.VRDESCPROMO=valor;

									valor=UtilitiesService.formatFloat(valor);
									if(data.discountType=='1'){
										valor="R$ "+valor;
									} else if(data.discountType=='2'){
										valor=valor+"%";
									}
									arrtemp.dsVRPROMO=valor;
									arrdata.push(arrtemp);
								}
							});
							var buscaPromocoesIntPayment = widget.getField('buscaPromocoesIntPayment');
							buscaPromocoesIntPayment.dataSourceFilter[4].value = Object.assign({}, arrdata);
							buscaPromocoesIntPayment.reload();

							widget.getAction('btnConfirmar').label='Confirmar';
							widget.getAction('btnConfirmar').isVisible=false;
							widget.getField('NRCPFINTEPROMO').readOnly = true;

							widget.getField('buscaPromocoesIntPayment').isVisible = true;
							widget.getField('buscaPromocoesIntWallet').isVisible = true;
							widget.getField('buscaPromocoesIntOffers').isVisible = true;

							widget.currentRow.IDPEDINTEPROMO = retSendCart.orderId;

							ScreenService.showMessage("Escolha uma promoção na lista de promoções disponiveis.", 'alert');
						}
					} else {
						ScreenService.showMessage(retConsultCart.message||'Erro, não foi possivel buscar as promoções.');
					}
					ScreenService.hideLoader();
				});
			});
		});
	};

	this.setPromocoesInt = function(widget){
		if(widget.getAction('btnConfirmar').label == 'Buscar'){
			return self.getPromocoesInt(widget);
		}
		var arrPromocaodeWallet = Array();
		var arrPromocaodePayment = Array();
		var arrPromocaodeOffers = Array();

        widget.getField('buscaPromocoesIntWallet').dataSource.data.forEach(function(data,i){
			var boAdd = false;
            if(data.NRSEQPROMOCOM == widget.getField('buscaPromocoesIntWallet').value().substr(0,3) ){
				boAdd=true;
            } else if('Carteira' == widget.getField('buscaPromocoesIntWallet').value().substr(0,8)){
				boAdd=true;
			}
			if(boAdd){
                widget.getField('buscaPromocoesIntWallet').dataSource.data[i].IDUTPROMOCOM='S';
                arrPromocaodeWallet.push(widget.getField('buscaPromocoesIntWallet').dataSource.data[i]);
			} else {
				widget.getField('buscaPromocoesIntWallet').dataSource.data[i].IDUTPROMOCOM='N';
			}
        });
        widget.getField('buscaPromocoesIntPayment').dataSource.data.forEach(function(data,i){
			var boAdd = false;
            if(data.NRSEQPROMOCOM == widget.getField('buscaPromocoesIntPayment').value().substr(0,3) ){
				boAdd=true;
            } else if(widget.getField('buscaPromocoesIntPayment').value().indexOf(data.IDPROMOCOM+" ")==0 ){
				boAdd=true;
			}
			if(boAdd){
                widget.getField('buscaPromocoesIntPayment').dataSource.data[i].IDUTPROMOCOM='S';
                arrPromocaodePayment.push(widget.getField('buscaPromocoesIntPayment').dataSource.data[i]);
			} else {
                widget.getField('buscaPromocoesIntPayment').dataSource.data[i].IDUTPROMOCOM='N';
			}
        });
		widget.getField('buscaPromocoesIntOffers').dataSource.data.forEach(function(data,i){
			var boAdd = false;
            if(data.NRSEQPROMOCOM == widget.getField('buscaPromocoesIntOffers').value().substr(0,3) ){
				boAdd = true;
            } else if(widget.getField('buscaPromocoesIntOffers').value().indexOf(data.IDPROMOCOM+" ")==0 ){
                boAdd = true;
			}
			if(boAdd){
				widget.getField('buscaPromocoesIntOffers').dataSource.data[i].IDUTPROMOCOM='S';
                arrPromocaodeOffers.push(widget.getField('buscaPromocoesIntOffers').dataSource.data[i]);
			} else {
				widget.getField('buscaPromocoesIntOffers').dataSource.data[i].IDUTPROMOCOM='N';
			}
        });
		cRow = {};
		var VRDESCONTO= 0;
		var TIPODESCONTO= 'P';
		cRow.CDSUPERVISORd= '';
		cRow.TIPODESCONTO= 'P';
		cRow.VRDESCONTO= 0;
		cRow.changed= true;
		PaymentRepository.findOne().then(function (payment) {
			var boAlterou = false;
			var boRemoveuOffers = false;
			if(arrPromocaodeOffers.length>0 && operatorData.modoHabilitado == 'B'){
				if(payment.ITEMVENDA){
					if(payment.ITEMVENDA.length>0){
						payment.ITEMVENDA.forEach(function(item,i){
							if(arrPromocaodeOffers[0].IDUTPROMOCOM=='S'){
								widget.retConsultCart.offers.data.forEach(function(offer){
									if(arrPromocaodeOffers[0].IDPROMOCOM==offer.applied.data.id){
										valor = String(offer.total);
										payment.DATASALE.TOTAL = UtilitiesService.getFloat(valor);
										payment.DATASALE.TOTALVENDA = UtilitiesService.getFloat(valor);
										payment.DATASALE.FALTANTE = UtilitiesService.getFloat(valor);
										offer.products.data.forEach(function(product){
											if(
												item.CDPRODUTO==product.productCode &&
												item.QTPRODCOMVEN==product.quantity &&
												String(item.ID)== String(product.index)
											){
												valor = String(product.value);
												valor=parseFloat(valor.replace(',', '.'));
												valor=UtilitiesService.formatFloat(valor);
												payment.ITEMVENDA[i].PRECO = valor;
												payment.ITEMVENDA[i].PRITEM = UtilitiesService.getFloat(valor);
												payment.ITEMVENDA[i].PRITOTITEM = UtilitiesService.getFloat(valor);
												boAlterou = true;
											}
										});
									}
								});
							}
						});
					}
				}
			} else if(arrPromocaodeOffers.length<1 && payment.descontoPromocoesIntOffers){
				boRemoveuOffers = true;
			}
			var promessa = (function(){ return new Promise.resolve(true); })();
			if(boAlterou){
				payment.descontoPromocoesIntOffers = arrPromocaodeOffers;
				payment.NRCPFINTEPROMO = widget.getField('NRCPFINTEPROMO').value();
				payment.IDPEDINTEPROMO = widget.getField('IDPEDINTEPROMO').value();
				promessa = PaymentRepository.save(payment);
				//ScreenService.showMessage('Uma Promoção Offers foi aplicada e alguns produtos podem ter recebido descontos, por favor verifique o novo total da venda.', 'alert');
			} else if(boRemoveuOffers){
				arrPromocaodeOffers = null;
				promessa = PaymentService.updateCartPrices(payment.chave, payment.ITEMVENDA, payment.CDCLIENTE, payment.CDCONSUMIDOR, null).then(function(result){
					payment.ITEMVENDA = result.CartPricesRepository;
					payment.DATASALE.TOTALVENDA = result.nothing.valorVenda;
					payment.DATASALE.TOTAL = result.nothing.valorVenda;
					payment.DATASALE.FALTANTE = result.nothing.valorVenda;
					payment.DATASALE.VRDESCONTO = 0;
					payment.DATASALE.PCTDESCONTO = '0';
					payment.DATASALE.TIPODESCONTO = 'P';
					payment.DATASALE.fidelityDetails = null;
					payment.DATASALE.FIDELITYDISCOUNT = 0;
					payment.DATASALE.cashbackUsed4ALL = 0;
					payment.DATASALE.FIDELITYVALUE = 0;
					payment.DATASALE.CPFUDS = null;
					payment.numeroProdutos = result.nothing.numeroProdutos;
					payment.descontoPromocoesIntOffers = null;
					return PaymentRepository.save(payment);
				});
			} else {
				arrPromocaodeOffers = null;
			}
			promessa.then(function(){
				if(arrPromocaodePayment.length<1 && arrPromocaodeWallet.length <1 ){
					return self.removeDesconto(cRow).then(function(){
						if((arrPromocaodeOffers||Array()).length>0 && operatorData.modoHabilitado == 'B'){
							return PaymentRepository.findOne().then(function(payment){
								payment.descontoPromocoesIntPayment = null;
								payment.descontoPromocoesIntWallet = null;
								payment.descontoPromocoesIntOffers = arrPromocaodeOffers;
								setTimeout(function(){self.attScreen(widget);},10);
								return PaymentRepository.save(payment);
							});
						} else {
							self.attScreen(widget);
						}
					});
				} else if(arrPromocaodePayment.length>0 && arrPromocaodeWallet.length >0){
					if(payment.DATASALE.TOTAL <= (0.01*payment.numeroProdutos)){
						ScreenService.showMessage('Não foi possível aplicar o desconto da Promoção. O valor máximo de desconto já foi atingido.', 'alert');
						return;
					}
					cRow.TIPODESCONTO= arrPromocaodeWallet[0].IDTPDESCPROMO;
					cRow.VRDESCONTO = UtilitiesService.getFloat(arrPromocaodeWallet[0].VRDESCPROMO);
					return PaymentService.handleApplyDiscount(cRow).then(function(handleApplyDiscountResult){
						if (handleApplyDiscountResult.error) {
							ScreenService.showMessage('Não foi possível aplicar o desconto da Promoção.', 'alert');
							return;
						}
						return PaymentRepository.findOne().then(function(payment){
						return ParamsPriceChart.findAll().then(function(paymentTypes){
							var stPagamentosDisponiveis = "";
							paymentTypes.forEach(function(data){
								if(data.CDTIPORECE == arrPromocaodePayment[0].IDPROMOCOM){
									if(stPagamentosDisponiveis==""){
										stPagamentosDisponiveis = data.DSBUTTON;
									} else {
										stPagamentosDisponiveis = stPagamentosDisponiveis+", "+data.DSBUTTON;
									}
								}
							});
							if(stPagamentosDisponiveis==""){
								ScreenService.showMessage('A promoção '+arrPromocaodePayment[0].NMPROMOCOM+' é condicionado ao meio de pagamento. Nenhum meio de pagamento compatível foi encontrado na base.', 'alert');
								return PaymentRepository.findOne().then(function(payment){
									arrPromocaodePayment = null;
									payment.descontoPromocoesIntPayment = arrPromocaodePayment;
									payment.descontoPromocoesIntWallet = arrPromocaodeWallet;
									payment.descontoPromocoesIntOffers = arrPromocaodeOffers;
									if(operatorData.modoHabilitado == 'B'){
										payment.NRCPFINTEPROMO = widget.getField('NRCPFINTEPROMO').value();
										payment.IDPEDINTEPROMO = widget.getField('IDPEDINTEPROMO').value();
									}
									return PaymentRepository.save(payment);
									//self.attScreen(widget);
								});
							}
							if(arrPromocaodePayment[0].IDTPDESCPROMO=="P"){
								var porcentagem1 = UtilitiesService.getFloat(payment.DATASALE.PCTDESCONTO);
								var porcentagem2 = arrPromocaodePayment[0].VRDESCPROMO;
								porcentagem1 = porcentagem1 / 100;
								porcentagem2 = porcentagem2 / 100;
								// exemplo 10% + 20% = 28% : (0.1+(0.2-(0.2*0.1)))*100
								var soma = (porcentagem1+(porcentagem2-(porcentagem2*porcentagem1)))*100;
								VRDESCONTO= soma;
								TIPODESCONTO= 'P';
							} else if(arrPromocaodePayment[0].IDTPDESCPROMO=="V"){
								VRDESCONTO= UtilitiesService.getFloat(payment.DATASALE.VRDESCONTO)+UtilitiesService.getFloat(arrPromocaodePayment[0].VRDESCPROMO);
								TIPODESCONTO= 'V';
							}
							cRow.TIPODESCONTO= TIPODESCONTO;
							cRow.VRDESCONTO = UtilitiesService.getFloat(VRDESCONTO);
							return PaymentService.handleApplyDiscount(cRow).then(function(handleApplyDiscountResult){
								if (handleApplyDiscountResult.error) {
									ScreenService.showMessage('Não foi possível aplicar o desconto da Promoção.', 'alert');
									return;
								}
								return PaymentRepository.findOne().then(function(payment){
									payment.descontoPromocoesIntPayment = arrPromocaodePayment;
									payment.descontoPromocoesIntWallet = arrPromocaodeWallet;
									payment.descontoPromocoesIntOffers = arrPromocaodeOffers;
									if(operatorData.modoHabilitado == 'B'){
										payment.NRCPFINTEPROMO = widget.getField('NRCPFINTEPROMO').value();
										payment.IDPEDINTEPROMO = widget.getField('IDPEDINTEPROMO').value();
									}
									setTimeout(function(){
										//ScreenService.showMessage("Os descontos das promoções foram aplicados na venda com sucesso.", 'alert');
										self.attScreen(widget);
										if(arrPromocaodePayment.length>0 && stPagamentosDisponiveis!=""){
											ScreenService.showMessage("Para confirmar a aplicação do desconto "+arrPromocaodePayment[0].NMPROMOCOM+", selecione um meio de pagamento compatível: "+stPagamentosDisponiveis, 'alert');
										}
									},10);
									return PaymentRepository.save(payment);
								});
							});
						});
						});
					});
				} else if(arrPromocaodePayment.length>0 || arrPromocaodeWallet.length>0){
					if(payment.DATASALE.TOTAL <= (0.01*payment.numeroProdutos)){
						ScreenService.showMessage('Não foi possível aplicar o desconto da Promoção. O valor máximo de desconto já foi atingido.', 'alert');
						return;
					}
					return ParamsPriceChart.findAll().then(function(paymentTypes){
						var stPagamentosDisponiveis = "";
						if(arrPromocaodePayment.length>0){
							paymentTypes.forEach(function(data){
								if(data.CDTIPORECE == arrPromocaodePayment[0].IDPROMOCOM){
									if(stPagamentosDisponiveis==""){
										stPagamentosDisponiveis = data.DSBUTTON;
									} else {
										stPagamentosDisponiveis = stPagamentosDisponiveis+", "+data.DSBUTTON;
									}
								}
							});
							if(stPagamentosDisponiveis==""){
								ScreenService.showMessage('A promoção '+arrPromocaodePayment[0].NMPROMOCOM+' é condicionado ao meio de pagamento. Nenhum meio de pagamento compatível foi encontrado na base.', 'alert');
								return PaymentRepository.findOne().then(function(payment){
									payment.descontoPromocoesIntPayment = null;
									payment.descontoPromocoesIntWallet = null;
									payment.descontoPromocoesIntOffers = arrPromocaodeOffers;
									if(operatorData.modoHabilitado == 'B'){
										payment.NRCPFINTEPROMO = widget.getField('NRCPFINTEPROMO').value();
										payment.IDPEDINTEPROMO = widget.getField('IDPEDINTEPROMO').value();
									}
									PaymentRepository.save(payment);
									//self.attScreen(widget);
								});
							}
						}
						cRow.TIPODESCONTO= (arrPromocaodePayment[0]||arrPromocaodeWallet[0]).IDTPDESCPROMO;
						cRow.VRDESCONTO = (arrPromocaodePayment[0]||arrPromocaodeWallet[0]).VRDESCPROMO;
						cRow.VRDESCONTO = UtilitiesService.getFloat(cRow.VRDESCONTO);
						return PaymentService.handleApplyDiscount(cRow).then(function(handleApplyDiscountResult){
							if (handleApplyDiscountResult.error) {
								ScreenService.showMessage('Não foi possível aplicar o desconto da Promoção.', 'alert');
								return;
							}
							return PaymentRepository.findOne().then(function(payment){
								payment.descontoPromocoesIntPayment = arrPromocaodePayment.length<1?null:arrPromocaodePayment;
								payment.descontoPromocoesIntWallet = arrPromocaodeWallet.length<1?null:arrPromocaodeWallet;
								payment.descontoPromocoesIntOffers = arrPromocaodeOffers;
								if(operatorData.modoHabilitado == 'B'){
									payment.NRCPFINTEPROMO = widget.getField('NRCPFINTEPROMO').value();
									payment.IDPEDINTEPROMO = widget.getField('IDPEDINTEPROMO').value();
								}
								setTimeout(function(){
								self.attScreen(widget);
								if(arrPromocaodePayment.length>0 && stPagamentosDisponiveis!=""){
									ScreenService.showMessage("Para confirmar a aplicação do desconto "+arrPromocaodePayment[0].NMPROMOCOM+", selecione um meio de pagamento compatível: "+stPagamentosDisponiveis, 'alert');
								}
								},10);
								return PaymentRepository.save(payment);
							});
						});
					});
				}
			});
		});
    };

	this.getSaldoCartaoTodo = function(widget){
		if(widget.getAction('ok').label=="Consultar"){
			card_number = widget.getField('card_number').value();
			if(!card_number){
				ScreenService.showMessage("Número do cartão não informado.", 'alert');
			}
			PaymentService.buscaSaldoCartaoTodo(
				operatorData.chave,
				widget.getField('card_number').value()
			).then(function(saldoCartaoTodo){
				saldoCartaoTodo = saldoCartaoTodo[0]||{"error":true,"message":"Não foi possível consultar o saldo."};
				if(saldoCartaoTodo){
					if(saldoCartaoTodo.error){
						if(saldoCartaoTodo.message){
							ScreenService.showMessage(saldoCartaoTodo.message, 'alert');
							return;
						}
					}
				}
				widget.getField('saldodisponivel').setValue(UtilitiesService.toCurrency(saldoCartaoTodo.balance));
				if(UtilitiesService.getFloat(saldoCartaoTodo.balance) > widget.FALTANTE){
					widget.getField('saldoutilizado').range.max = UtilitiesService.getFloat(widget.FALTANTE);
					widget.getField('saldoutilizado').setValue(UtilitiesService.toCurrency(widget.FALTANTE));
				} else {
					widget.getField('saldoutilizado').range.max = UtilitiesService.getFloat(saldoCartaoTodo.balance);
					widget.getField('saldoutilizado').setValue(UtilitiesService.toCurrency(saldoCartaoTodo.balance));
				}
				widget.getField('saldoutilizado').isVisible = true;
				widget.getField('saldodisponivel').isVisible = true;
				widget.getField('card_password').isVisible = true;
				widget.getField('card_number').readOnly = true;
				widget.getAction('ok').label='Confirmar';
			});
		} else if(widget.getAction('ok').label=="Confirmar"){
			if(!widget.getField('card_password').value()){
				ScreenService.showMessage("Informe a senha do Cartão Todo.", 'alert');
				return;
			}
			field = widget.getField('saldoutilizado');
			var value = field.value();
			value = UtilitiesService.removeCurrency(value);
			var min = field.range.min;
			var max = field.range.max;
			if(max){
				max = UtilitiesService.getFloat(max);
				if(max > widget.FALTANTE){
					max = UtilitiesService.getFloat(widget.FALTANTE);
				}
			}
			if ((value <= min) || isNaN(value) || value===0) {
				ScreenService.showMessage(MESSAGE.VR_MIN, 'alert');
				field.setValue(min);
				return;
			} else if (typeof max === 'number') {
				if (value > max) {
					ScreenService.showMessage(MESSAGE.VR_MAX, 'alert');
					field.setValue(max);
					return false;
				}
			}
			ScreenService.confirmMessage("Confirma a utilização de "+UtilitiesService.toCurrency(value)+" do saldo do Cartão Todo?", 'question',
				function(){
					PaymentRepository.findOne().then(function (paymentData) {
						adiantamento = false;
						widget.tiporece.cartaoTodo = widget.currentRow;
						self.openPaymentPopup(widget.container, widget.tiporece, value, true, false);
					});
				}, function(){}
			);
		}
	};
	
	this.criarPopUpsPaymentMenu = function(widget){
		if(widget.widgetsNaoCriadas){
			//setTimeout(function(){
				widget.widgetsNaoCriadas.forEach(function(widgetNaocriada){
					if(!widget.getWidget(widgetNaocriada.name)){
						//setTimeout(function(){
							widget.widgets.push(metaDataFactory.widgetFactory(widgetNaocriada,widget));
						//},50);
					}
				});
			//},50);
		}
	};

	this.criaWidget = function(widget, nome){
		if(widget.widgetsNaoCriadas){
			widget.widgetsNaoCriadas.forEach(function(widgetNaocriada){
				if(!widget.getWidget(widgetNaocriada.name) && widgetNaocriada.name==nome){
					widget.widgets.push(metaDataFactory.widgetFactory(widgetNaocriada,widget));
				}
			});
		}
		return widget.getWidget(nome);
	};

	this.removePopUpsPaymentMenu=function(args){
		if(args.owner.widgetsNaoCriadas){
			setTimeout(function(){
				args.owner.widgetsNaoCriadas.forEach(function(widgetNaoCriada){
					args.owner.widgets.forEach(function(widgetCriada,indice){
						if(widgetNaoCriada.name == widgetCriada.name){
							args.owner.widgets.splice(indice, 1);
						}
					});
				});
			},50);
		}
	};

	this.paymentMenuOnEnter=function(args){
		self.attStripeData(args.owner);
		self.initButtons(args.owner.container);
		setTimeout(function(){
			self.prepareCPFPopup(args.owner.container);
			self.solicitaTel(args.owner.container);
			self.prepareFidelityCRM(args.owner.container);
			self.trataPagamentosIncompletos();
			setTimeout(function(){
				PaymentRepository.findOne().then(function(payment){
					if(existe(payment,"DATASALE.FALTANTE")){
						if(payment.DATASALE.FALTANTE<=0){
							self.handleShowPaymentList(args.owner.container.getWidget('paymentList'));
						}
					}
				});
			},250);
		},50);
		ScreenService.hideLoader();
	};

	this.paymentMenuOnEnterAdiantamento=function(args){
		self.attStripeData(args.owner);
		self.initButtons(args.owner.container);
		self.handlePaymentScreen(args.owner.container.getWidget('paymentList'), 'advancePaymentMenu');
		self.prepareCPFPopup(args.owner.container, true);
		self.trataPagamentosIncompletos();
	};

	this.paymentStripeOnEnter=function(args){
		self.limpadesconto = true;
		self.handleActionsPaymentStripe(args.owner.container);
		self.handlePromocoesIntPopup(args.owner.container);
		ScreenService.hideLoader();
	};

	this.paymentStripeOnEnterAdiantamento=function(args){
		self.handleConsumerPopupAdvance(args.owner.container.getWidget('popupConsumidorBalcao'));
		AccountController.limpaDesconto(args.owner.container.getWidget('discountPopup'));
	};
	

	this.imprimeCupomTEFParcelado = function(isCostumerVia, data) {
		if(isCostumerVia) {
			ScreenService.confirmMessage(MESSAGE.PRINT_VIA_CLI, 'question',
				function() {
					PrinterService.printerCommand(PrinterService.TEXT_COMMAND, data);
					self.printerSpaceCommand(1);
					PrinterService.printerInit();
				},
				function() {}
			);
		} else {
			PrinterService.printerCommand(PrinterService.TEXT_COMMAND, data);
			self.printerSpaceCommand(1);
			PrinterService.printerInit();
		}
	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('PaymentController', PaymentController);
});
